package com.hzya.frame.plugin.lets.dingtalk.utils;


import cn.hutool.json.JSONUtil;
import com.hzya.frame.plugin.lets.constant.OverallConstant;
import com.hzya.frame.plugin.lets.dingtalk.callback.service.impl.CallBackServiceImpl;
import com.hzya.frame.plugin.lets.dingtalk.vo.SysFileVO;
import org.apache.commons.httpclient.HttpClient;
import org.apache.commons.httpclient.methods.PostMethod;
import org.apache.commons.httpclient.methods.RequestEntity;
import org.apache.commons.httpclient.methods.StringRequestEntity;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.stereotype.Component;

import java.util.HashMap;
import java.util.Map;

@Component
public class PushU8CFileUtil {
    protected static Logger logger = LogManager.getLogger(PushU8CFileUtil.class);

    /**
     * 推送u8c单据附件
     * @Param vouchId 单据主键
     * @Param sysFileVO 文件信息
     */
    public static void pushFile(String vouchId, SysFileVO sysFileVO) throws Exception{

        // 服务器访问地址及端口,例如 http://ip:port
        String serviceUrl = OverallConstant.getOverAllValue("u8cApiUrl");
        // 服务名,例如 /u8cloud/api/cmp/hj/insert
        String serviceName = "/u8cloud/api/file/upload/base64";

        Map<String, Object> map = new HashMap<String, Object>();
        map.put("trantype", OverallConstant.getOverAllValue("u8cApiTrantypeCode")); // 档案翻译方式，枚举值为：编码请录入 code， 名称请录入 name， 主键请录入 pk
        map.put("system", OverallConstant.getOverAllValue("u8cApiSystemCode")); // 系统编码
        map.put("usercode", OverallConstant.getOverAllValue("u8cApiUsercodeCode")); // 用户
        map.put("password", OverallConstant.getOverAllValue("u8cApiPasswordCode")); // 密码，需要 MD5 加密后录入

        Map<String,String> fileMap=new HashMap<>();
        fileMap.put("content",sysFileVO.getBaseCode());
        fileMap.put("creator","tbadmin");//制单人code
        fileMap.put("file_name",sysFileVO.getFileName());
        fileMap.put("upload_path",vouchId);//单据主键
        String jsonFileMap = JSONUtil.toJsonStr(fileMap);
        String json="{\"file\":["+jsonFileMap+"]}";
        System.out.println(json);

        //上传
        HttpClient httpClient = new HttpClient();
        PostMethod httpPost = new PostMethod(serviceUrl+serviceName);
        httpPost.setRequestHeader("content-type","application/json;charset=utf-8");
        for (Map.Entry<String, Object> entry : map.entrySet()) {
            httpPost.setRequestHeader(entry.getKey(), entry.getValue()
                    .toString());
        }

        RequestEntity entity = new StringRequestEntity(json,"application/json", "UTF-8");
        httpPost.setRequestEntity(entity);
        httpClient.executeMethod(httpPost);
        String responseBodyAsString = httpPost.getResponseBodyAsString();
        logger.info("推送u8c单据附件，推送单据主键：{}，u8c返回信息：{}",vouchId,responseBodyAsString);


    }
}
