package com.hzya.frame.plugin.lets.plugin.sales;

import cn.hutool.core.date.DateUtil;
import cn.hutool.core.lang.Assert;
import cn.hutool.core.util.StrUtil;
import cn.hutool.http.HttpRequest;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.hzya.frame.base.PluginBaseEntity;
import com.hzya.frame.beanutil.BeanUtil;
import com.hzya.frame.plugin.lets.constant.ExportConstant;
import com.hzya.frame.plugin.lets.constant.OverallConstant;
import com.hzya.frame.plugin.lets.constant.ProfilesActiveConstant;
import com.hzya.frame.plugin.lets.dao.*;
import com.hzya.frame.plugin.lets.entity.*;
import com.hzya.frame.plugin.lets.ofs.dao.IOfsPassiveorderDetailDao;
import com.hzya.frame.plugin.lets.ofs.dao.IOfsPassiveorderHeaderDao;
import com.hzya.frame.plugin.lets.ofs.dao.ITocofsReturngoodsDao;
import com.hzya.frame.plugin.lets.ofs.dao.ITocofsReturngoodsDetailedDao;
import com.hzya.frame.plugin.lets.ofs.entity.OfsPassiveorderDetailEntity;
import com.hzya.frame.plugin.lets.ofs.entity.OfsPassiveorderHeaderEntity;
import com.hzya.frame.plugin.lets.ofs.entity.TocofsReturngoodsDetailedEntity;
import com.hzya.frame.plugin.lets.ofs.entity.TocofsReturngoodsEntity;
import com.hzya.frame.plugin.lets.ofsvo.QueryOfsSoSaleOutVo;
import com.hzya.frame.plugin.lets.queryvo.ExtIntegrationTaskLivingDetailsQueryVo;
import com.hzya.frame.plugin.lets.queryvo.StartAndEndVo;
import com.hzya.frame.plugin.lets.u8cdto.*;
import com.hzya.frame.plugin.lets.util.*;
import com.hzya.frame.split.SplitListByCountUtil;
import com.hzya.frame.ttxofs.dto.ofssalesordersearch.DetailsDto;
import com.hzya.frame.ttxofs.dto.ofssalesordersearch.HeaderDetailsDto;
import com.hzya.frame.ttxofs.dto.ofssalesordersearch.HeaderDto;
import com.hzya.frame.ttxofs.dto.ofssalesordersearch.SaleOrderMessageDto;
import com.hzya.frame.ttxofs.dto.passivestorage.PassiveStorageResponse;
import com.hzya.frame.ttxofs.dto.returngoodordersearch.RerturnGoodsOrderSearchData;
import com.hzya.frame.ttxofs.dto.returngoodordersearch.RerturnGoodsOrderSearchDetails;
import com.hzya.frame.ttxofs.dto.returngoodordersearch.RerturnGoodsOrderSearchHeader;
import com.hzya.frame.ttxofs.dto.stock.StockinOrderSearchResponse;
import com.hzya.frame.ttxofs.service.OfsUnifiedService;
import com.hzya.frame.web.entity.BaseResult;
import com.hzya.frame.web.entity.JsonResultEntity;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;

import java.math.BigDecimal;
import java.time.LocalDate;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.util.*;
import java.util.concurrent.locks.ReentrantLock;
import java.util.function.Predicate;
import java.util.stream.Collectors;

/**
 * TOB业务，无源入库单(TOB) -> 推送U8C 红字销售订单、交易成功部分生成红字应收单
 *
 * @author makejava
 * @since 2025-03-17 13:47:31
 */
public class PassiveWarehouseReceiptToB extends PluginBaseEntity {

    Logger logger = LoggerFactory.getLogger(PassiveWarehouseReceiptToB.class);

    private static final ReentrantLock LOCK1 = new ReentrantLock(true);

    private static final ReentrantLock LOCK2 = new ReentrantLock(true);

    @Autowired
    private IBdCorpDao iBdCorpDao;

    @Autowired
    private IBdInvbasdocDao iBdInvbasdocDao;

    @Autowired
    private QueryU8CEntityUtil queryU8CEntityUtil;

    @Autowired
    private OfsUnifiedService ofsUnifiedService;

    @Autowired
    private IBdTaxitemsDao iBdTaxitemsDao;

    @Autowired
    private IBdCalbodyDao iBdCalbodyDao;

    @Autowired
    private QueryBdBusitypeUtil queryBdBusitypeUtil;

    @Autowired
    private IBdStordocDao iBdStordocDao;

    @Autowired
    private IBdSalestruDao iBdSalestruDao;

    @Autowired
    private IBdCumandocDao iBdCumandocDao;

    @Autowired
    private IBdDeptdocDao iBdDeptdocDao;

    @Autowired
    private IBdCubasdocDao iBdCubasdocDao;

    @Autowired
    private IBdDefdocDao iBdDefdocDao;

    @Autowired
    private IBdInvmandocDao iBdInvmandocDao;

    @Autowired
    private ITocofsReturngoodsDao iTocofsReturngoodsDao;

    @Autowired
    private ITocofsReturngoodsDetailedDao iTocofsReturngoodsDetailedDao;

    @Autowired
    private AfterSalesOrderUtil afterSalesOrderUtil;

    @Autowired
    private ShopTobOrToCUtil shopTobOrToCUtil;

    @Autowired
    private OffsetTimeTime offsetTimeTime;

    @Autowired
    private IIcGeneralHDao iIcGeneralHDao;

    @Autowired
    private IIcGeneralBDao iIcGeneralBDao;

    @Autowired
    private OfsStandardUtil ofsStandardUtil;

    @Autowired
    private RdclUtil rdclUtil;

    @Autowired
    private ISoSaleDao iSoSaleDao;

    @Autowired
    private IOfsPassiveorderDetailDao iOfsPassiveorderDetailDao;

    @Autowired
    private ISoSaleorderBDao iSoSaleorderBDao;

    @Autowired
    private ISoSaleinvoiceDao iSoSaleinvoiceDao;

    @Autowired
    private BalanceUnitPriceUtil balanceUnitPriceUtil;

    private static final String STOCK = "stock";

    private static final String TRAN = "tran";

    private static final String PROD_FILED = "prod";

    private static final String VNOTETYPE = "RETURN";

    private static final Object PUSH_LOCK1 = new Object();

    private static final Object PUSH_LOCK2 = new Object();

    @Autowired
    private IOfsPassiveorderHeaderDao iOfsPassiveorderHeaderDao;

    @Override
    public void initialize() {
        logger.info(getPluginLabel() + "執行初始化方法initialize()");
    }

    @Override
    public void destroy() {
        logger.info(getPluginLabel() + "執行銷毀方法destroy()");
    }

    @Override
    public String getPluginId() {
        return "sales.PassiveWarehouseReceiptToB";
    }

    @Override
    public String getPluginName() {
        return "OFS无源入库单(TOB)生成U8C红字销售订单或红字发票";
    }

    @Override
    public String getPluginLabel() {
        return "OFS无源入库单(TOB)生成U8C红字销售订单或红字发票";
    }

    @Override
    public String getPluginType() {
        return "3";
    }

    @Override
    public JsonResultEntity executeBusiness(JSONObject requestJson) throws Exception {
        logger.info("触发调用：{}" + getPluginName());
        try {
            Thread thread = new Thread(new Runnable() {
                @Override
                public void run() {
                    long startMillis = System.currentTimeMillis();
                    logger.info("executeBusiness方法调用开始：" + getPluginName() + "-插件");

                    try {
                        String param = String.valueOf(requestJson.get("param"));
                        String sceneType = String.valueOf(requestJson.get("sceneType"));//sceneType：stock、tran
                        if (ProfilesActiveConstant.TYPE_VBILLCODE.equals(requestJson.get("type"))) {
                            //按单号
                            if (param != null && !"".equals(param)) {
                                startImplementByCode(param, sceneType);
                            }
                        } else if (ProfilesActiveConstant.TYPE_TIME_FRAME.equals(requestJson.get("type"))) {
                            //前台页面功能日期推送，或者接口调用也行
                            Assert.notNull(sceneType, "sceneType参数不能为空");
                            Assert.notNull(!"".equals(sceneType), "sceneType参数不能为空");
                            String craeteDateStr = computingTime(param);
                            if (craeteDateStr != null && !"".equals(craeteDateStr)) {
                                splitDateAndPush(craeteDateStr, sceneType);
                            }
                        } else {
                            if (ProfilesActiveConstant.LETS_PROFILES_ACTIVE.equals(PROD_FILED)) {
                                //实时执行，每1分钟调度一次
                                StartAndEndVo startAndEndVo = offsetTimeTime.getCurrentDateRange();
                                startImplementByStockTime(startAndEndVo.getStart_time(), startAndEndVo.getEnd_time());
                                startImplementByTradeTime(startAndEndVo.getStart_time(), startAndEndVo.getEnd_time());
                            }
                        }
                    } catch (Exception e) {
                        logger.error("executeBusiness方法异常", e);
                    }
                    long endMillis = System.currentTimeMillis();
                    logger.info("executeBusiness方法调用结束：" + getPluginName() + "-插件 执行耗时：{}", (endMillis - startMillis));
//        return null;
                }
            }, "执行插件：" + getPluginName());
            thread.start();

            if (requestJson != null && requestJson.get("type") != null && ProfilesActiveConstant.TYPE_DETAIL_ERROR.equals(requestJson.get("type"))) {
                try {
                    thread.join();
                } catch (Exception e) {
                    logger.error("thread.join();抛出异常", e);
                }
            }
        } catch (Exception e) {
            logger.error("executeBusiness方法抛出异常", e);
        }
        return BaseResult.getSuccessMessageEntity("插件执行成功");
    }

    /**
     * 库存同步，按指定时间拉取
     *
     * @author liuyang
     */
    public void startImplementByStockTime(String startTime, String endTime) throws Exception {
        try {
            long startMillis = System.currentTimeMillis();
            String threadNameStrStart = StrUtil.format("OFS无源入库单(TOB)同步U8C销售订单(库存同步) 开始时间：{} 结束时间：{}", startTime, endTime);
            logger.info(threadNameStrStart);

            Assert.notNull(startTime, "startTime不能为空");
            Assert.notNull(endTime, "endTime不能为空");

            //2024年8月19日 15:47:51 查询出U8C里标记的店铺TOB属性
            String tobShop = shopTobOrToCUtil.getCommaShop("TOB");
            List<PassiveStorageResponse.Data> passiveStorageResponseDataDtoArrayList = new ArrayList<>();
            QueryOfsSoSaleOutVo queryOfsSoSaleOutVo = new QueryOfsSoSaleOutVo();
            queryOfsSoSaleOutVo.setRelatedAt_start(startTime);
            queryOfsSoSaleOutVo.setRelatedAt_end(endTime);
            queryOfsSoSaleOutVo.setClientCode("LETS");
            queryOfsSoSaleOutVo.setPageNo(1L);
            queryOfsSoSaleOutVo.setPageSize(50L);
            queryOfsSoSaleOutVo.setStoreCode(tobShop);
            ofsStandardUtil.queryOfsPassiveComponents(queryOfsSoSaleOutVo, passiveStorageResponseDataDtoArrayList, 1L, "ofs.passive.order.search");
            logger.info("插件：{}  (库存)O接口返回行数：{} 时间段：{} {}", getPluginName(), passiveStorageResponseDataDtoArrayList.size(), startTime, endTime);
            printOfsDocCode(passiveStorageResponseDataDtoArrayList, startTime, endTime, "无源入库单");

            if (passiveStorageResponseDataDtoArrayList.size() > 0) {
                String filter_company = queryU8CEntityUtil.queryBdDefDocByListPk();
                passiveStorageResponseDataDtoArrayList.removeIf(new Predicate<PassiveStorageResponse.Data>() {
                    @Override
                    public boolean test(PassiveStorageResponse.Data headerDetailsDto) {
                        PassiveStorageResponse.Header header = headerDetailsDto.getHeader();
                        if (header != null && header.getCompanyCode() != null) {
                            if (filter_company.contains(header.getCompanyCode().trim())) {
                                return true;
                            }
                        }
                        return false;
                    }
                });
                getSetStock(passiveStorageResponseDataDtoArrayList);
            } else {
                logger.info("没有查询到任何数据！不需要同步");
            }

            long endMillis = System.currentTimeMillis();
            String threadNameStrEnd = StrUtil.format("OFS无源入库单(TOB)同步U8C销售订单(库存同步) 开始时间：{} 结束时间：{} 耗时：{}", startTime, endTime, (endMillis - startMillis));
            logger.info(threadNameStrEnd);
        } catch (Exception e) {
            logger.error("startImplementByStockTime方法抛出异常", e);
        }
    }

    /**
     * 库存同步，按指定时间拉取
     *
     * @author liuyang
     */
    public void startImplementByTradeTime(String startTime, String endTime) throws Exception {
        try {
            long startMillis = System.currentTimeMillis();
            String threadNameStrStart = StrUtil.format("OFS无源入库退款到账(TOB)同步U8C发票 开始时间：{} 结束时间：{}", startTime, endTime);
            logger.info(threadNameStrStart);

            Assert.notNull(startTime, "startTime不能为空");
            Assert.notNull(endTime, "endTime不能为空");

            //生成一个时间范围
            String tobShop = shopTobOrToCUtil.getCommaShop("TOB");
            List<PassiveStorageResponse.Data> passiveStorageResponseDataDtoArrayList = new ArrayList<>();
            QueryOfsSoSaleOutVo queryOfsSoSaleOutVo = new QueryOfsSoSaleOutVo();
            queryOfsSoSaleOutVo.setRelatedAt_start(startTime);
            queryOfsSoSaleOutVo.setRelatedAt_end(endTime);
            queryOfsSoSaleOutVo.setClientCode("LETS");
            queryOfsSoSaleOutVo.setPageNo(1L);
            queryOfsSoSaleOutVo.setPageSize(50L);
            queryOfsSoSaleOutVo.setStoreCode(tobShop);
            ofsStandardUtil.queryOfsPassiveComponents(queryOfsSoSaleOutVo, passiveStorageResponseDataDtoArrayList, 1L, "ofs.passive.order.search");
            logger.info("插件：{}  (库存)O接口返回行数：{} 时间段：{} {}", getPluginName(), passiveStorageResponseDataDtoArrayList.size(), startTime, endTime);
            printOfsDocCode(passiveStorageResponseDataDtoArrayList, startTime, endTime, "无源入库单退货");

            if (passiveStorageResponseDataDtoArrayList.size() > 0) {
                String filter_company = queryU8CEntityUtil.queryBdDefDocByListPk();
                passiveStorageResponseDataDtoArrayList.removeIf(new Predicate<PassiveStorageResponse.Data>() {
                    @Override
                    public boolean test(PassiveStorageResponse.Data headerDetailsDto) {
                        PassiveStorageResponse.Header header = headerDetailsDto.getHeader();
                        if (header != null && header.getCompanyCode() != null) {
                            if (filter_company.contains(header.getCompanyCode().trim())) {
                                return true;
                            }
                        }
                        return false;
                    }
                });
                getSetTrade(passiveStorageResponseDataDtoArrayList);
            } else {
                logger.info("没有查询到任何数据！不需要同步");
            }

            long endMillis = System.currentTimeMillis();
            String threadNameStrEnd = StrUtil.format("OFS无源入库退款到账(TOB)同步U8C发票 开始时间：{} 结束时间：{} 耗时：{}", startTime, endTime, (endMillis - startMillis));
            logger.info(threadNameStrEnd);
        } catch (Exception e) {
            logger.error("startImplementByTradeTime方法抛出异常", e);
        }
    }

    /**
     * 根据售后入库单单号拉取
     *
     * @author liuyang
     */
    public void startImplementByCode(String code, String sceneType) throws Exception {
        try {
            long startMillis = System.currentTimeMillis();
            String threadNameStrStart = StrUtil.format("OFS无源入库(TOB)同步U8C销售订单(库存同步) 售后入库单号：{}", code);
            logger.info(threadNameStrStart);
            Assert.notNull(code, "code不能为空");

            //2024年8月19日 15:47:51 查询出U8C里标记的店铺TOB属性
//            String tobShop = shopTobOrToCUtil.getCommaShop("TOB");

            List<PassiveStorageResponse.Data> passiveStorageResponseDataList = new ArrayList<>();
            QueryOfsSoSaleOutVo queryOfsSoSaleOutVo = new QueryOfsSoSaleOutVo();
            queryOfsSoSaleOutVo.setReceiptCode(code);
            queryOfsSoSaleOutVo.setClientCode("LETS");
            queryOfsSoSaleOutVo.setPageNo(1L);
            queryOfsSoSaleOutVo.setPageSize(50L);
            ofsStandardUtil.queryOfsPassiveComponents(queryOfsSoSaleOutVo, passiveStorageResponseDataList, 1L, "ofs.passive.order.search");
            logger.info("数据返回行数：{}", passiveStorageResponseDataList.size());
            splicingPrintingOrderNumber(passiveStorageResponseDataList, sceneType, null, null, code);

            if (passiveStorageResponseDataList.size() > 0) {
                if (sceneType.equals("stock")) {
                    String filter_company = queryU8CEntityUtil.queryBdDefDocByListPk();
                    passiveStorageResponseDataList.removeIf(new Predicate<PassiveStorageResponse.Data>() {
                        @Override
                        public boolean test(PassiveStorageResponse.Data headerDetailsDto) {
                            PassiveStorageResponse.Header header = headerDetailsDto.getHeader();
                            if (header != null && header.getCompanyCode() != null) {
                                if (filter_company.contains(header.getCompanyCode().trim())) {
                                    return true;
                                }
                            }
                            return false;
                        }
                    });
                    getSetStock(passiveStorageResponseDataList);
                } else if (sceneType.equals("tran")) {
                    getSetTrade(passiveStorageResponseDataList);
                }
            } else {
                logger.info("没有查询到任何数据！不需要同步");
            }

            long endMillis = System.currentTimeMillis();
            String threadNameStrEnd = StrUtil.format("OFS无源入库(TOB)同步U8C销售订单(库存同步) 售后入库单号：{} 耗时：{}", code, (endMillis - startMillis));
            logger.info(threadNameStrEnd);
        } catch (Exception e) {
            logger.error("startImplementByCode方法抛出异常", e);
        }
    }

    /**
     * 库存同步：环境预配置
     *
     * @author liuyang
     */
    private void getSetStock(List<PassiveStorageResponse.Data> returnGoodHeaderDetailsDataDtoArrayList) throws Exception {
        LOCK1.lock();
        try {
            //过滤成功的数据
            List<PassiveStorageResponse.Data> data = filterDataStock(returnGoodHeaderDetailsDataDtoArrayList);
            //保存到mysql
            batchInsert(data);
            //执行推送主逻辑
            implementStock(data);
        } catch (Exception e) {
            logger.error("getSetStock方法抛出异常", e);
        } finally {
            LOCK1.unlock();
        }
    }

    /**
     * 到账完成：环境预配置
     *
     * @author liuyang
     */
    private void getSetTrade(List<PassiveStorageResponse.Data> returnGoodHeaderDetailsDataDtoArrayList) throws Exception {
        LOCK2.lock();
        try {
            //过滤成功的数据
            List<PassiveStorageResponse.Data> data = filterDataTran(returnGoodHeaderDetailsDataDtoArrayList);
            //保存到mysql
            batchInsert(data);
            //执行推送主逻辑
            implementSuccessfulTrade(data);
        } catch (Exception e) {
            logger.error("getSetTrade方法抛出异常", e);
        } finally {
            LOCK2.unlock();
        }
    }

    /**
     * 库存：过滤掉成功的数据
     *
     * @author liuyang
     */
    private List<PassiveStorageResponse.Data> filterDataStock(List<PassiveStorageResponse.Data> passiveStorageResponseDataDtoArrayList) throws Exception {
        List<OfsPassiveorderDetailEntity> ofsPassiveorderDetailEntitiesList = new ArrayList<>();
        //查询每行无源入库单，对应的推送状态
        if (passiveStorageResponseDataDtoArrayList != null && passiveStorageResponseDataDtoArrayList.size() > 0) {
            List<List<PassiveStorageResponse.Data>> lists = SplitListByCountUtil.splitListByCount(passiveStorageResponseDataDtoArrayList, 1000);
            for (int i = 0; i < lists.size(); i++) {
                List<PassiveStorageResponse.Data> data = lists.get(i);
                String idStr = commaConcatenatedPrimaryKeyStock(data);
                List<OfsPassiveorderDetailEntity> ofsPassiveorderDetailEntities = queryStockTocOutLog(idStr);
                ofsPassiveorderDetailEntitiesList.addAll(ofsPassiveorderDetailEntities);
            }
        }
        return filterDataRowsAsPushOrFailedStock(ofsPassiveorderDetailEntitiesList, passiveStorageResponseDataDtoArrayList);
    }

    /**
     * 过滤库存同步业务，筛选出未推送、或者失败的数据行，使用批处理并且直接在内存中计算这样比较高效
     *
     * @param tocofsReturngoodsDetailedEntityList     无源入库单推送状态信息
     * @param returnGoodHeaderDetailsDataDtoArrayList O 无源入库单对象封装
     * @author liuyang
     */
    private List<PassiveStorageResponse.Data> filterDataRowsAsPushOrFailedStock(List<OfsPassiveorderDetailEntity> tocofsReturngoodsDetailedEntityList, List<PassiveStorageResponse.Data> returnGoodHeaderDetailsDataDtoArrayList) throws Exception {
        List<PassiveStorageResponse.Data> targetHeaderDetailsDtoList = new ArrayList<>();

        if (returnGoodHeaderDetailsDataDtoArrayList != null && returnGoodHeaderDetailsDataDtoArrayList.size() > 0) {
            //如果推送状态为 null，则赋予""，便于 stream 计算
            List<OfsPassiveorderDetailEntity> resultList = tocofsReturngoodsDetailedEntityList.stream().map(obj -> {
                if (obj.getNewstate() == null) {
                    obj.setNewstate("");
                }
                return obj;
            }).collect(Collectors.toList());
            //汇总每个 id 对应的推送状态
            Map<String, String> no2NameMap = resultList.stream().collect(Collectors.toMap(OfsPassiveorderDetailEntity::getId, OfsPassiveorderDetailEntity::getNewstate));

            //字段Y(成功)或者为H(待处理)可以视为成功，完成了小段业务闭环的数据行
            String succeseeY = "Y";
            String succeseeH = "H";
            for (int i = 0; i < returnGoodHeaderDetailsDataDtoArrayList.size(); i++) {
                PassiveStorageResponse.Data data = returnGoodHeaderDetailsDataDtoArrayList.get(i);
                PassiveStorageResponse.Header header = data.getHeader();
                List<PassiveStorageResponse.Details> details = data.getDetails();

                List<PassiveStorageResponse.Details> targetDetails = new ArrayList<>();
                for (int j = 0; j < details.size(); j++) {
                    PassiveStorageResponse.Details details1 = details.get(j);
                    Boolean isSuccess = false;

                    String newstate = no2NameMap.get(details1.getId());
                    if (newstate != null && !"".equals(newstate) && (succeseeY.equals(newstate) || succeseeH.equals(newstate))) {
                        isSuccess = true;
                    }
                    if (!isSuccess) {
                        targetDetails.add(details1);
                    }
                }
                if (targetDetails.size() > 0) {
                    //如果明细行中，还存在未推送或者失败的数据，则需要更新明细行
                    //相当于覆盖对应的对象
                    data.setDetails(targetDetails);
                    targetHeaderDetailsDtoList.add(data);
                }
            }
        }
        return targetHeaderDetailsDtoList;
    }

    /**
     * 筛选出未推送、或者失败的数据行，过滤库存同步业务
     *
     * @param tocofsReturngoodsDetailedEntityList     日志行状态
     * @param returnGoodHeaderDetailsDataDtoArrayList 返回结果
     * @author liuyang
     */
    private List<PassiveStorageResponse.Data> filterDataRowsAsPushOrFailedTran(List<OfsPassiveorderDetailEntity> tocofsReturngoodsDetailedEntityList, List<PassiveStorageResponse.Data> returnGoodHeaderDetailsDataDtoArrayList) throws Exception {
        List<PassiveStorageResponse.Data> targetHeaderDetailsDtoList = new ArrayList<>();

        if (returnGoodHeaderDetailsDataDtoArrayList != null && returnGoodHeaderDetailsDataDtoArrayList.size() > 0) {
            //字段Y(成功)或者为H(待处理)可以视为成功，完成了小段业务闭环的数据行
            String succeseeY = "Y";
            String succeseeH = "H";
            for (int i = 0; i < returnGoodHeaderDetailsDataDtoArrayList.size(); i++) {
                PassiveStorageResponse.Data data = returnGoodHeaderDetailsDataDtoArrayList.get(i);
                PassiveStorageResponse.Header header = data.getHeader();
                List<PassiveStorageResponse.Details> details = data.getDetails();

                List<PassiveStorageResponse.Details> targetDetails = new ArrayList<>();
                for (int j = 0; j < details.size(); j++) {
                    PassiveStorageResponse.Details details1 = details.get(j);
                    Boolean isSuccess = false;
                    String newstate = null;
                    if (tocofsReturngoodsDetailedEntityList != null && tocofsReturngoodsDetailedEntityList.size() > 0) {
                        for (int k = 0; k < tocofsReturngoodsDetailedEntityList.size(); k++) {
                            OfsPassiveorderDetailEntity ofsPassiveorderDetailEntity = tocofsReturngoodsDetailedEntityList.get(k);
                            if (ofsPassiveorderDetailEntity.getId().equals(details1.getId())) {
                                newstate = ofsPassiveorderDetailEntity.getNewstate2();
                                if (succeseeY.equals(newstate) || succeseeH.equals(newstate)) {
                                    isSuccess = true;
                                }
                            }
                        }
                    }
                    if (!isSuccess) {
                        targetDetails.add(details1);
                    }
                }
                if (targetDetails.size() > 0) {
                    //如果明细行中，还存在未推送或者失败的数据，则需要更新明细行
                    data.setDetails(targetDetails);
                    targetHeaderDetailsDtoList.add(data);
                }
            }
        }
        return targetHeaderDetailsDtoList;
    }

    /**
     * 批查询toc退货入库日志，查询的量由splitListByCount方法控制
     *
     * @author liuyang
     */
    private List<OfsPassiveorderDetailEntity> queryStockTocOutLog(String idStr) throws Exception {
        List<OfsPassiveorderDetailEntity> tocofsReturngoodsDetailedEntities = null;
        if (idStr != null && !"".equals(idStr.trim())) {
            OfsPassiveorderDetailEntity ofsPassiveorderDetailEntity = new OfsPassiveorderDetailEntity();
            ofsPassiveorderDetailEntity.setIds(idStr);
            tocofsReturngoodsDetailedEntities = iOfsPassiveorderDetailDao.query(ofsPassiveorderDetailEntity);
        } else {
            logger.error("idStr为空，无法查询数据！");
        }
        return tocofsReturngoodsDetailedEntities;
    }

    /**
     * 逗号拼接字符串主键，作为批处理的一部分，方便下一步的批量查询操作
     * 入库和退款导致完成都可以通用
     *
     * @author liuyang
     */
    private String commaConcatenatedPrimaryKeyStock(List<PassiveStorageResponse.Data> headerDetailsDtoList2) throws Exception {
        StringBuffer idStr = new StringBuffer();
        if (headerDetailsDtoList2 != null && headerDetailsDtoList2.size() > 0) {
            for (int i = 0; i < headerDetailsDtoList2.size(); i++) {
                PassiveStorageResponse.Data data = headerDetailsDtoList2.get(i);
                PassiveStorageResponse.Header header = data.getHeader();
                List<PassiveStorageResponse.Details> details = data.getDetails();
                for (int j = 0; j < details.size(); j++) {
                    PassiveStorageResponse.Details details1 = details.get(j);
                    Assert.notNull(details1.getId(), "O明细主键不能为空！");
                    Assert.state(!"".equals(details1.getId()), "O明细主键不能为空！");
                    idStr.append(details1.getId());
                    idStr.append(",");
                }
            }
        }
        if (idStr.length() > 0) {
            return idStr.substring(0, idStr.length() - 1);
        }
        return null;
    }

    /**
     * 确认收入：过滤掉成功的数据
     *
     * @author liuyang
     */
    private List<PassiveStorageResponse.Data> filterDataTran(List<PassiveStorageResponse.Data> returnGoodHeaderDetailsDataDtoArrayList) throws Exception {
        synchronized (PUSH_LOCK2) {
            List<OfsPassiveorderDetailEntity> tocofsReturngoodsDetailedEntityList = new ArrayList<>();
            if (returnGoodHeaderDetailsDataDtoArrayList != null && returnGoodHeaderDetailsDataDtoArrayList.size() > 0) {
                List<List<PassiveStorageResponse.Data>> lists = SplitListByCountUtil.splitListByCount(returnGoodHeaderDetailsDataDtoArrayList, 100);
                for (int i = 0; i < lists.size(); i++) {
                    List<PassiveStorageResponse.Data> data = lists.get(i);
                    String idStr = commaConcatenatedPrimaryKeyStock(data);
                    List<OfsPassiveorderDetailEntity> ofsPassiveorderDetailEntities = queryStockTocOutLog(idStr);
                    tocofsReturngoodsDetailedEntityList.addAll(ofsPassiveorderDetailEntities);
                }
            }
            return filterDataRowsAsPushOrFailedTran(tocofsReturngoodsDetailedEntityList, returnGoodHeaderDetailsDataDtoArrayList);
        }
    }

    /**
     * 保存抓取到的数据到mysql底表，如果底表里已经存在，则会忽略，并且发生更新
     *
     * @param passiveStorageResponseDataDtoArrayList 需要保存到 Mysql 底表的数据行，采用批量插入的方式
     * @author liuyang
     */
    private void batchInsert(List<PassiveStorageResponse.Data> passiveStorageResponseDataDtoArrayList) throws Exception {
        if (passiveStorageResponseDataDtoArrayList != null && passiveStorageResponseDataDtoArrayList.size() > 0) {
            List<PassiveStorageResponse.Header> headerDetailsDtoList1 = new ArrayList<>();
            List<PassiveStorageResponse.Details> headerDetailsDtoList2 = new ArrayList<>();

            for (PassiveStorageResponse.Data index : passiveStorageResponseDataDtoArrayList) {
                //主表、明细表
                PassiveStorageResponse.Header header = index.getHeader();
                List<PassiveStorageResponse.Details> details = index.getDetails();
                if (details != null && details.size() > 0) {
                    for (PassiveStorageResponse.Details passiveStorageResponseDetails : details) {
                        passiveStorageResponseDetails.setHeader(header);
                    }
                }
                headerDetailsDtoList1.add(header);
                headerDetailsDtoList2.addAll(details);
            }

            //每100作为一个批次插入主表，根据主键（id）判断是否重复，如果重复的，则不进行插入
            List<List<PassiveStorageResponse.Header>> lists = SplitListByCountUtil.splitListByCount(headerDetailsDtoList1, 100);
            for (int i = 0; i < lists.size(); i++) {
                List<PassiveStorageResponse.Header> headers = lists.get(i);

                final Throwable[] childException = {null};
                long startTime = System.currentTimeMillis();
                Thread thread = new Thread(new Runnable() {
                    @Override
                    public void run() {
                        try {
                            List<OfsPassiveorderHeaderEntity> ofsPassiveorderHeaderEntities = copyHeaderDto(headers);
                            if (ofsPassiveorderHeaderEntities.size() > 0) {
                                logger.info("插入底表{}个对象（表头）", ofsPassiveorderHeaderEntities.size());
                                iOfsPassiveorderHeaderDao.entityInsertOrUpdateBatch(ofsPassiveorderHeaderEntities);
                            } else {
                                logger.info("ofsPassiveorderHeaderEntities：没有对象被插入表头底表");
                            }
                        } catch (Exception e) {
                            logger.error("线程保存无源件主表抛出异常", e);
                            childException[0] = e;
                        }
                    }
                });
                thread.start();
                try {
                    thread.join();
                } catch (Exception e) {
                    logger.error("线程保存TOC退货主表抛出异常", e);
                    childException[0] = e;
                }
                long endTime = System.currentTimeMillis();
                logger.info("插入或更新无源入库单表-耗时：{}", (endTime - startTime));

                //如果子线程抛出异常，则反馈到主线程方便排查
                if (childException[0] != null) {
                    Assert.state(false, childException[0].getMessage());
                }
            }

            //插入明细表
            List<List<PassiveStorageResponse.Details>> lists1 = SplitListByCountUtil.splitListByCount(headerDetailsDtoList2, 100);
            for (int i = 0; i < lists1.size(); i++) {
                List<PassiveStorageResponse.Details> details = lists1.get(i);
                List<OfsPassiveorderDetailEntity> ofsPassiveorderDetailEntities = copyDetailsDto(details);

                final Throwable[] childException = {null};
                long startTime = System.currentTimeMillis();
                Thread thread = new Thread(new Runnable() {
                    @Override
                    public void run() {
                        try {
                            if (ofsPassiveorderDetailEntities.size() > 0) {
                                logger.info("插入底表{}个对象（表体）", ofsPassiveorderDetailEntities.size());
                                iOfsPassiveorderDetailDao.entityInsertOrUpdateBatch(ofsPassiveorderDetailEntities);
                            } else {
                                logger.info("ofsPassiveorderDetailEntities：没有对象被插入表头底表");
                            }
                        } catch (Exception e) {
                            logger.error("线程保存TOC退货明细抛出异常", e);
                            childException[0] = e;
                        }
                    }
                });
                thread.start();
                try {
                    thread.join();
                } catch (Exception e) {
                    logger.error("线程保存无源件明细表抛出异常", e);
                    childException[0] = e;
                }
                long endTime = System.currentTimeMillis();
                logger.info("插入或更新TOC退货入库表体-耗时：{}", (endTime - startTime));
                //如果子线程抛出异常，则反馈到主线程方便排查
                if (childException[0] != null) {
                    Assert.state(false, childException[0].getMessage());
                }
            }
        }
    }

    /**
     * 代码同步逻辑
     *
     * @param passiveStorageResponseDataDtoArrayList 需要推送的TOB无源入库单
     * @author liuyang
     */
    private void implementStock(List<PassiveStorageResponse.Data> passiveStorageResponseDataDtoArrayList) throws Exception {
        if (passiveStorageResponseDataDtoArrayList != null) {
            logger.info("TOC无源入库单：{}行需要进行数据转换", passiveStorageResponseDataDtoArrayList.size());
        }
        if (passiveStorageResponseDataDtoArrayList != null && passiveStorageResponseDataDtoArrayList.size() > 0) {
            try {
                // 查询基本档案
                String sceneType = "stock";
                List<OrderToBHeaderDtoV2> orderToBHeaderDtoV2s = queryBasicArchivesStock(passiveStorageResponseDataDtoArrayList, sceneType);
                // 查询U8C业务流程
                BdBusitypeEntity bdBusitypeEntity = u8cOperationFlow();
                // 查询销售收发类别
//                BdRdclEntity bdRdclEntity = rdclUtil.queryRdClObject("201");

                for (int i = 0; i < orderToBHeaderDtoV2s.size(); i++) {
                    OrderToBHeaderDtoV2 orderToBHeaderDtoV2 = orderToBHeaderDtoV2s.get(i);
                    PassiveStorageResponse.Header header = orderToBHeaderDtoV2.getHeader();
                    List<PassiveStorageResponse.Details> details = orderToBHeaderDtoV2.getDetails();

                    try {
                        //销售公司、发货公司
                        BdCorpEntity bdCorpEntity = orderToBHeaderDtoV2.getBdCorpEntity();
                        //发货库存组织
                        BdCalbodyEntity bdCalbodyEntity = orderToBHeaderDtoV2.getBdCalbodyEntity();
                        //入库参数
                        BdStordocEntity bdStordocEntity = orderToBHeaderDtoV2.getBdStordocEntity();
                        //销售组织
                        BdSalestruEntity bdSalestruEntity = orderToBHeaderDtoV2.getBdSalestruEntity();
                        //业务部门
                        BdDeptdocEntity bdDeptdocEntity = orderToBHeaderDtoV2.getBdDeptdocEntity();
                        //客商基本档案
                        BdCubasdocEntity bdCubasdocEntity = orderToBHeaderDtoV2.getBdCubasdocEntity();
                        //客商基本档案
                        BdCumandocEntity bdCumandocEntity = orderToBHeaderDtoV2.getBdCumandocEntity();
                        //发货公司
                        BdCorpEntity deliverGoodsCorp = orderToBHeaderDtoV2.getDeliverGoodsCorp();
                        //平台档案
                        BdDefdocEntity platformArchives = orderToBHeaderDtoV2.getPlatformArchives();
                        //U8C店铺档案
                        BdDefdocEntity shopArchives = orderToBHeaderDtoV2.getShopArchives();
                        //生成业务日期
                        String generateBusinessDate = createGenerateBusinessDate(header);
                        //U8C销售订单
                        SoSaleEntity soSaleEntity = orderToBHeaderDtoV2.getSoSaleEntity();
                        //OFS销售订单
                        SaleOrderMessageDto saleOrderMessageDto = orderToBHeaderDtoV2.getSaleOrderMessageDto();
                        //OFS售后订单
                        RerturnGoodsOrderSearchData ofsRertunOrder1 = orderToBHeaderDtoV2.getOfsRertunOrder();
                        //OFS收发类别
                        BdRdclEntity bdRdclEntity = orderToBHeaderDtoV2.getBdRdclEntity();

                        SaleorderRequestDto saleorderRequestDto = new SaleorderRequestDto();
                        SaleorderRequestParentDto saleorderRequestParentDto = new SaleorderRequestParentDto();
                        saleorderRequestParentDto.setDbilldate(generateBusinessDate);//单据日期
                        saleorderRequestParentDto.setBretinvflag("Y");//退货标记
                        saleorderRequestParentDto.setCbiztype(bdBusitypeEntity.getPkBusitype());//业务流程
                        saleorderRequestParentDto.setCcalbodyid(bdCalbodyEntity.getPkCalbody());//库存组织
                        saleorderRequestParentDto.setCcustomerid(bdCumandocEntity.getPkCumandoc());//客户=开票单位=收货单位=表体收货单位=收货单位
                        saleorderRequestParentDto.setCdeptid(bdDeptdocEntity.getPkDeptdoc());//部门
                        saleorderRequestParentDto.setCemployeeid(null);//业务员
                        saleorderRequestParentDto.setCoperatorid(OverallConstant.getOverAllValue("u8cApiZdrPK"));//制单人
                        saleorderRequestParentDto.setCreceiptcorpid(bdCumandocEntity.getPkCumandoc());//开票单位
                        saleorderRequestParentDto.setCreceiptcustomerid(bdCumandocEntity.getPkCumandoc());//收货单位
                        saleorderRequestParentDto.setCsalecorpid(bdSalestruEntity.getCsalestruid());//销售组织
                        saleorderRequestParentDto.setCwarehouseid(bdStordocEntity.getPkStordoc());//仓库
                        saleorderRequestParentDto.setDapprovedate(generateBusinessDate);//审核日期
                        saleorderRequestParentDto.setNdiscountrate("100.000000");//整单折扣
                        saleorderRequestParentDto.setPk_corp(bdCorpEntity.getPkCorp());//公司id
                        saleorderRequestParentDto.setVdef17(ProfilesActiveConstant.sourceSystem1);//来源系统

                        //原单单号、原单主键，销售发票就是靠这个字段关联的
                        saleorderRequestParentDto.setVdef19(header.getReceiptCode());
                        saleorderRequestParentDto.setVdef20(header.getId());

                        //平台
                        saleorderRequestParentDto.setPk_defdoc2(platformArchives.getPkDefdoc());
                        saleorderRequestParentDto.setVdef2(platformArchives.getDocname());

                        //店铺
                        saleorderRequestParentDto.setPk_defdoc1(shopArchives.getPkDefdoc());
                        saleorderRequestParentDto.setVdef1(shopArchives.getDocname());

                        //收发类别
                        saleorderRequestParentDto.setPk_defdoc3(bdRdclEntity.getPkRdcl());
                        saleorderRequestParentDto.setVdef3(bdRdclEntity.getRdname());

                        //单据红字标识
                        saleorderRequestParentDto.setPk_defdoc16(OverallConstant.getOverAllValue("u8c自定义项档案-单据红字标识-Y主键"));
                        saleorderRequestParentDto.setVdef16(OverallConstant.getOverAllValue("u8c自定义项档案-单据红字标识-Y名称"));

                        saleorderRequestDto.setParentvo(saleorderRequestParentDto);

                        List<SaleorderRequestChildrenDto> saleorderRequestChildrenDtoList = new ArrayList<>();
                        saleorderRequestDto.setChildrenvo(saleorderRequestChildrenDtoList);

                        //验证是否为指定的店铺，如果为true，则取结存价
                        Boolean isCheckShopChoose = balanceUnitPriceUtil.checkOfsShop(header.getStoreCode());

                        //把汇总好的出库单明细行合并成一行
                        for (int j = 0; j < details.size(); j++) {
                            PassiveStorageResponse.Details details1 = details.get(j);
                            //存货管理档案：取发货公司的存货管理档案
                            BdInvmandocEntity bdInvmandocEntity = queryInventoryMan(details1, bdCalbodyEntity.getPkCorp());
                            //存货基础档案
                            BdInvbasdocEntity bdInvbasdocEntity = queryStockBasicArchives(bdInvmandocEntity.getPkInvmandoc(), deliverGoodsCorp.getPkCorp());
                            //根据存货基础档案编码，查询当前存货的税率
                            BdTaxitemsEntity bdTaxitemsEntity1 = queryBdTaxitems(bdInvbasdocEntity.getInvcode());
                            //取对应的售后订单明细，主要是取这个价格
                            RerturnGoodsOrderSearchDetails afterSalesOrder = findAfterSalesOrder(details1, ofsRertunOrder1);

                            String tax = new BigDecimal(bdTaxitemsEntity1.getTaxratio()).divide(new BigDecimal(100), 20, BigDecimal.ROUND_HALF_UP).setScale(2, BigDecimal.ROUND_HALF_UP).stripTrailingZeros().toPlainString();

                            //查询收支项目
//                            BdInvclEntity bdInvclEntity = queryU8CEntityUtil.queryBdInvbasdocByBdInvcl(bdInvbasdocEntity);
//                            BdCostsubjEntity bdCostsubjEntity = queryU8CEntityUtil.queryBdCostsubj(bdInvclEntity);

                            // 如果是海外的店铺，则税率为零
                            String exportVaue = ExportConstant.exportConstant.get(header.getStoreCode());
                            if (exportVaue != null) {
                                tax = "0";
                            }

                            StringBuffer calculationFormula = new StringBuffer();//计算公式
//                            BigDecimal noriginalcurprice = null;//无税单价
//                            BigDecimal noriginalcurmny = null;//无税金额
//                            BigDecimal noriginalcurtaxprice = null;//含税单价
//                            BigDecimal noriginalcursummny = null;//价税合计
//                            BigDecimal noriginalcurtaxmny = null;//税额
                            String totalAmount = null;
                            try {
//                                Assert.notNull(stockinB.getTotalAmount(), "退货入库单总金额不能为空 明细行对象:{}", JSON.toJSONString(stockinB));
                                Assert.notNull(details1.getQuantity(), "实收数量不能为空 无源入库单号:{} 无源入库单明细主键：{}", details1.getReceiptCode(), details1.getId());
                                //确定实退金额，可能为O的实退金额，也可能是结存价和采购价
                                totalAmount = getFloorPrice(isCheckShopChoose, bdInvmandocEntity, header, afterSalesOrder, calculationFormula, details1, bdInvbasdocEntity);
                                Assert.notNull(totalAmount, "无法确定实退金额");

//                                noriginalcurtaxprice = new BigDecimal(totalAmount).divide(new BigDecimal(stockinB.getReceivedQty()), 20, BigDecimal.ROUND_HALF_UP).setScale(4, BigDecimal.ROUND_HALF_UP);
//                                noriginalcurprice = noriginalcurtaxprice.divide(new BigDecimal(1).add(new BigDecimal(tax)), 20, BigDecimal.ROUND_HALF_UP).setScale(4, BigDecimal.ROUND_HALF_UP);
//                                noriginalcurmny = noriginalcurprice.multiply(new BigDecimal(stockinB.getReceivedQty())).setScale(2, BigDecimal.ROUND_HALF_UP);
//                                noriginalcursummny = noriginalcurtaxprice.multiply(new BigDecimal(stockinB.getReceivedQty())).setScale(2, BigDecimal.ROUND_HALF_UP);
//                                noriginalcurtaxmny = noriginalcursummny.subtract(noriginalcurmny).setScale(2, BigDecimal.ROUND_HALF_UP);
                            } catch (Exception e) {
                                logger.error("TOB无源件金额计算错误", e);
                                Assert.state(false, "TOB无源件金额计算错误，原因：{}", e.getMessage());
                            }

                            //判断是否为赠品
                            Boolean isblargessflag = false;
                            if ("0".equals(new BigDecimal(totalAmount).stripTrailingZeros().toPlainString())) {
                                isblargessflag = true;
                            }
                            SaleorderRequestChildrenDto saleorderRequestChildrenDto = new SaleorderRequestChildrenDto();
                            saleorderRequestChildrenDto.setBlargessflag(isblargessflag);//是否赠品
                            saleorderRequestChildrenDto.setCadvisecalbodyid(bdCalbodyEntity.getPkCalbody());//发货库存组织
                            saleorderRequestChildrenDto.setCbodywarehouseid(bdStordocEntity.getPkStordoc());//发货仓库
                            saleorderRequestChildrenDto.setCconsigncorpid(deliverGoodsCorp.getPkCorp());//发货公司
                            saleorderRequestChildrenDto.setCcurrencytypeid("00010000000000000001");//币种
                            saleorderRequestChildrenDto.setCinventoryid(bdInvmandocEntity.getPkInvmandoc());//存货id
                            saleorderRequestChildrenDto.setCreceiptcorpid(bdCumandocEntity.getPkCumandoc());//收货单位
                            saleorderRequestChildrenDto.setDconsigndate(generateBusinessDate);//计划发货日期
                            saleorderRequestChildrenDto.setDdeliverdate(generateBusinessDate);//	要求收货日期
                            saleorderRequestChildrenDto.setNexchangeotobrate("1.00000000");//折本汇率
                            saleorderRequestChildrenDto.setNitemdiscountrate("100.000000");//单品折扣
                            saleorderRequestChildrenDto.setNnumber("-" + details1.getQuantity());//数量
                            saleorderRequestChildrenDto.setNoriginalcurdiscountmny("0");//折扣额
//                            saleorderRequestChildrenDto.setNoriginalcurmny("-" + noriginalcurmny.stripTrailingZeros().toPlainString());//无税金额
//                            saleorderRequestChildrenDto.setNoriginalcurnetprice(noriginalcurprice.stripTrailingZeros().toPlainString());//无税净价
//                            saleorderRequestChildrenDto.setNoriginalcurprice(noriginalcurprice.stripTrailingZeros().toPlainString());//无税单价
//                            saleorderRequestChildrenDto.setNoriginalcursummny("-" + noriginalcursummny.stripTrailingZeros().toPlainString());//价税合计
                            saleorderRequestChildrenDto.setNoriginalcursummny("-" + new BigDecimal(totalAmount).setScale(2, BigDecimal.ROUND_HALF_UP).stripTrailingZeros().toPlainString());//价税合计 新逻辑
//                            saleorderRequestChildrenDto.setNoriginalcurtaxmny("-" + noriginalcurtaxmny.stripTrailingZeros().toPlainString());//税额
//                            saleorderRequestChildrenDto.setNoriginalcurtaxnetprice(noriginalcurtaxprice.stripTrailingZeros().toPlainString());//含税净价
//                            saleorderRequestChildrenDto.setNoriginalcurtaxprice(noriginalcurtaxprice.stripTrailingZeros().toPlainString());//含税单价
                            //税率
                            if ("0".equals(tax)) {
                                saleorderRequestChildrenDto.setNtaxrate("0");
                            } else {
                                saleorderRequestChildrenDto.setNtaxrate(new BigDecimal(bdTaxitemsEntity1.getTaxratio()).stripTrailingZeros().toPlainString());
                            }
                            saleorderRequestChildrenDto.setVdef20(details1.getId());//原单明细主键
//                            saleorderRequestChildrenDto.setVdef2(bdCostsubjEntity.getCostname());//收支项目
//                            saleorderRequestChildrenDto.setPk_defdoc2(bdCostsubjEntity.getPkCostsubj());
                            saleorderRequestChildrenDtoList.add(saleorderRequestChildrenDto);

                            details1.setDef1(totalAmount);//计算应收
                            details1.setDef2(calculationFormula.toString());//计算公式
                        }
                        //记录成功
                        //销售订单单据推送到u8c
                        List<SaleorderRequestDto> saleorderRequestDtoList = new ArrayList<>();
                        saleorderRequestDtoList.add(saleorderRequestDto);

                        synchronized (PUSH_LOCK1) {
                            Boolean aBoolean = checkTobOrder(header.getId(), header.getReceiptCode());
                            if (!aBoolean) {
                                logger.error("经过SQL查询判断，在U8C(红字)销售订单不存在OFS无源入库单号为：{} OFS无源入库主键为：{}的单据，将调用U8C接口执行推送！", header.getReceiptCode(), header.getId());
                                Map<String, List<SaleorderRequestDto>> stringStringMap = new HashMap<>();
                                stringStringMap.put("saleorder", saleorderRequestDtoList);
                                SoSaleResultRootDto soSaleResultRootDto = sendU8CTOCOrder(JSON.toJSONString(stringStringMap));
                                String vreceiptcode = null;
                                String csaleid = null;
                                String pk_corp = null;
                                if (soSaleResultRootDto != null) {
                                    SoSaleResultHeadDto parentvo = soSaleResultRootDto.getParentvo();
                                    List<SoSaleResultBodyDto> childrenvo = soSaleResultRootDto.getChildrenvo();
                                    vreceiptcode = parentvo.getVreceiptcode();
                                    csaleid = parentvo.getCsaleid();
                                    pk_corp = parentvo.getPk_corp();
                                }
                                logger.info("TOB无源入库-红字销售订单编号：{} 销售订单主键：{} 销售公司：{}", vreceiptcode, csaleid, pk_corp);
                                //记录成功
                                updateSuccessOrFail1(details, "Y", "success", vreceiptcode, csaleid);
                            } else {
                                logger.error("经过SQL查询判断，在U8C(红字)销售订单存在OFS无源入库单号为：{} OFS无源入库主键为：{}的单据，为了避免造成单据重复，不推送到U8C！", header.getReceiptCode(), header.getId());
                            }
                        }
                    } catch (Exception e) {
                        logger.error("TOB售后收入推送U8C失败", e);
                        //记录失败
                        String message = e.getMessage();
                        if (message == null) {
                            message = "未知错误";
                        }
                        updateSuccessOrFail1(details, "N", message, null, null);
                    }
                }
            } catch (Exception e) {
                logger.error("TOB无源件外层转换逻辑抛出异常", e);
            }
        }
    }

    /**
     * 2024年7月31日 10:34:09
     * 生成业务日期，以发货时间作为业务日期
     *
     * @author liuyang
     */
    private String createGenerateBusinessDate(PassiveStorageResponse.Header header) {
        String code = null;
        if (header != null && header.getReceiptCode() != null) {
            code = header.getReceiptCode();
        }
        if (header != null && header.getRelatedAt() != null) {
            String relatedAt = header.getRelatedAt();
            String businessFormat = null;
            try {
                Date dbill = DateUtil.parse(relatedAt);
                businessFormat = DateUtil.format(dbill, "yyyy-MM-dd");
            } catch (Exception e) {
                logger.error("业务日期生成失败relatedAt(O 关联时间)解析异常：{} O 无源入库单号：{}", e.getMessage(), code);
                Assert.state(false, "业务日期生成失败closedAt(O 关联时间)解析异常：{} O 无源入库单号：{}", e.getMessage(), code);
            }
            return businessFormat;
        } else {
            logger.error("业务日期生成失败relatedAt(O 关联时间)不能为空 O 无源入库单号:{}", code);
            Assert.state(false, "业务日期生成失败relatedAt(O 关联时间)不能为空 O 无源入库单号:{}", code);
            return null;
        }
    }

    /**
     * 库存同步，档案转换
     *
     * @author liuyang
     */
    private List<OrderToBHeaderDtoV2> queryBasicArchivesStock(List<PassiveStorageResponse.Data> passiveStorageResponseDataDtoArrayList, String sceneType) throws Exception {
        if (passiveStorageResponseDataDtoArrayList != null) {
            logger.info("库存同步：需要把OFS档案转换为U8C档案的O数据条数：{}", passiveStorageResponseDataDtoArrayList.size());
        }
        List<OrderToBHeaderDtoV2> orderToBHeaderDtoArrayList = new ArrayList<>();
        List<ErrorHeaderDetailsDtoDtoV3> errorHeaderDetailsDtoDtoList = new ArrayList<>();

        if (passiveStorageResponseDataDtoArrayList != null && passiveStorageResponseDataDtoArrayList.size() > 0) {
            for (int i = 0; i < passiveStorageResponseDataDtoArrayList.size(); i++) {
                PassiveStorageResponse.Data data = passiveStorageResponseDataDtoArrayList.get(i);
                PassiveStorageResponse.Header header = data.getHeader();
                List<PassiveStorageResponse.Details> details = data.getDetails();

                try {
                    //查询OFS售后订单
                    Assert.notNull(header.getReturnOrderCode(), "无源入库单对应的售后订单号不能为空 无源入库单：{}" + header.getReceiptCode());
                    RerturnGoodsOrderSearchData ofsRertunOrder = afterSalesOrderUtil.getOfsRertunOrder(header.getReturnOrderCode().trim());
                    Assert.notNull(ofsRertunOrder, "无法查询到OFS售后订单 编码：{}", header.getReturnOrderCode());

                    //查询OFS销售订单
                    Assert.notNull(ofsRertunOrder.getHeader().getRefOrderCode(), "销售订单编码不能为空 售后订单单号：{}", ofsRertunOrder.getHeader().getRefOrderCode());
                    SaleOrderMessageDto saleOrderMessageDto = null;
                    try {
                        Assert.notNull(ofsRertunOrder.getHeader().getRefOrderCode(), "ofsRertunOrder.getHeader().getRefOrderCode()不能为空！");
                        saleOrderMessageDto = afterSalesOrderUtil.getOfsOrder(ofsRertunOrder.getHeader().getRefOrderCode().trim());
                    } catch (Exception e) {
                        logger.error("查询出售后订单错误，失败原因：{}", e.getMessage());
                        Assert.state(false, "查询出售后订单错误，失败原因：{}", e.getMessage());
                    }
                    List<HeaderDetailsDto> headerDetailsDtoList = saleOrderMessageDto.getData();
                    if (headerDetailsDtoList == null || headerDetailsDtoList.size() == 0) {
                        Assert.state(false, "无法查询到OFS销售订单，查询路径：OFS销售出库单 -> OFS售后订单 -> OFS销售订单 OFS售后订单：{}", ofsRertunOrder.getHeader().getCode());
                    }
                    HeaderDetailsDto headerDetailsDto = headerDetailsDtoList.get(0);
                    HeaderDto header2 = headerDetailsDto.getHeader();
                    List<DetailsDto> details1 = headerDetailsDto.getDetails();

                    if (saleOrderMessageDto == null) {
                        Assert.state(false, "没有匹配到售后订单，系统业务无法完成");
                    }
                    HeaderDto header1 = saleOrderMessageDto.getData().get(0).getHeader();
                    String memberId = header1.getMemberId();

                    //会员id
//                    memberId = "GYS00002";
                    Assert.notNull(memberId, "TOB销售订单(OFS)表头会员id不能为空，否则无法匹配U8C客商档案！");
                    Assert.state(!"".equals(memberId.trim()), "TOB销售订单(OFS)表头会员id不能为空，否则无法匹配U8C客商档案！");

                    //查询对应的收发类别
                    if (header1.getSubOrderType() == null || "".equals(header1.getSubOrderType().trim())) {
                        header1.setSubOrderType("SALES");
                    }
                    BdRdclEntity bdRdclEntity = rdclUtil.queryRdClObject(header1.getSubOrderType().trim());
                    Assert.notNull(bdRdclEntity, "根据收发类别编码：{} 无法匹配到U8C收发类别");

                    // 销售公司、发货公司
                    String companyCode = header.getCompanyCode();
                    Assert.notNull(companyCode, "O表头公司不能为空");
                    String replaceCompanyCode = queryU8CEntityUtil.queryBdDefDocByPkDefDocList(companyCode.trim());
                    Assert.notNull(replaceCompanyCode, "replaceCompanyCode不能为空！");

                    BdCorpEntity bdCorpEntity = new BdCorpEntity();
                    bdCorpEntity.setDr(0);
                    bdCorpEntity.setDataSourceCode("lets_u8c");
                    bdCorpEntity.setUnitcode(replaceCompanyCode);
                    List<BdCorpEntity> bdCorpEntityList = iBdCorpDao.query(bdCorpEntity);
                    if (bdCorpEntityList.size() == 0) {
                        Assert.state(false, "根据O货主编码{}，无法匹配到U8C销售公司", replaceCompanyCode);
                    } else if (bdCorpEntityList.size() >= 2) {
                        Assert.state(false, "根据O货主编码{}，匹配到U8C销售公司{}个", replaceCompanyCode, bdCorpEntityList.size());
                    }

                    // 发货库存组织
                    BdCalbodyEntity bdCalbodyEntity = new BdCalbodyEntity();
                    bdCalbodyEntity.setDr(0);
                    bdCalbodyEntity.setDataSourceCode("lets_u8c");
                    bdCalbodyEntity.setPkCorp(bdCorpEntityList.get(0).getPkCorp());
                    List<BdCalbodyEntity> bdCalbodyEntities = iBdCalbodyDao.query(bdCalbodyEntity);
                    if (bdCalbodyEntities.size() == 0) {
                        Assert.state(false, "根据U8C发货公司{}，无法匹配到U8C发货库存组织", bdCorpEntityList.get(0).getPkCorp());
                    } else if (bdCalbodyEntities.size() >= 2) {
                        Assert.state(false, "根据U8C发货公司{}，匹配到U8C发货库存组织{}个", bdCorpEntityList.get(0).getPkCorp(), bdCalbodyEntities.size());
                    }

                    // 仓库
                    String facilityCode = header.getFacilityCode();
                    Assert.notNull(facilityCode, "O售后入库单仓库facilityCode字段不能为空");
                    BdStordocEntity bdStordocEntity = new BdStordocEntity();
                    bdStordocEntity.setDr(0L);
                    bdStordocEntity.setDataSourceCode("lets_u8c");
                    bdStordocEntity.setPkCalbody(bdCalbodyEntities.get(0).getPkCalbody());
                    bdStordocEntity.setStorcode(facilityCode.trim());
                    List<BdStordocEntity> bdStordocEntityList = iBdStordocDao.query(bdStordocEntity);
                    if (bdStordocEntityList.size() == 0) {
                        Assert.state(false, "根据O仓库编码+U8C发货库存组织主键，无法匹配到U8C仓库", facilityCode, bdCalbodyEntities.get(0).getPkCalbody());
                    } else if (bdStordocEntityList.size() >= 2) {
                        Assert.state(false, "根据O仓库编码+U8C发货库存组织主键，匹配到U8C仓库多个", facilityCode, bdCalbodyEntities.get(0).getPkCalbody());
                    }

                    //销售组织
                    //2024年8月13日 10:35:05 已经和佳妮在微信确认，U8C销售公司编码与U8C销售组织编码保持一致，因此通过销售公司编码匹配
                    BdSalestruEntity bdSalestruEntity = new BdSalestruEntity();
                    bdSalestruEntity.setDr(0);
                    bdSalestruEntity.setDataSourceCode("lets_u8c");
                    bdSalestruEntity.setVsalestrucode(bdCorpEntityList.get(0).getUnitcode());
                    List<BdSalestruEntity> bdSalestruEntityList = iBdSalestruDao.query(bdSalestruEntity);
                    if (bdSalestruEntityList.size() == 0) {
                        Assert.state(false, "根据U8C销售公司编码：{}，无法匹配到U8C销售组织", bdCorpEntityList.get(0).getUnitcode());
                    } else if (bdSalestruEntityList.size() >= 2) {
                        Assert.state(false, "根据U8C销售公司编码：{}，无法匹配到U8C销售组织", bdCorpEntityList.get(0).getUnitcode());
                    }

                    //业务部门
                    //2024年8月14日 10:38:37 已经和佳妮确认
                    List<BdDeptdocEntity> bdDeptdocEntityList = null;
                    if (header2.getDepartmentType() == null || "".equals(header2.getDepartmentType().trim())) {
                        logger.info("OFS销售订单号：{} 不存在部门字段！", header2.getCode());
                        String deptName = "业务部门";
                        BdDeptdocEntity bdDeptdocEntity = new BdDeptdocEntity();
                        bdDeptdocEntity.setDataSourceCode("lets_u8c");
                        bdDeptdocEntity.setDr(0);
                        bdDeptdocEntity.setDeptname(deptName);
                        bdDeptdocEntity.setPkCorp(bdCorpEntityList.get(0).getPkCorp());
                        bdDeptdocEntityList = iBdDeptdocDao.query(bdDeptdocEntity);
                        if (bdDeptdocEntityList.size() == 0) {
                            Assert.state(false, "默认部门：根据部门名称：{} 公司id：{}，无法匹配到U8C销售组织", deptName, bdCorpEntityList.get(0).getPkCorp());
                        } else if (bdDeptdocEntityList.size() >= 2) {
                            Assert.state(false, "默认部门：根据部门名称：{} 公司id：{}，匹配到U8C销售组织{}个", deptName, bdCorpEntityList.get(0).getPkCorp());
                        }
                    } else {
                        logger.info("OFS销售订单号：{} 存在部门字段：{}！", header2.getCode(), header2.getDepartmentType());
                        String departmentType = header2.getDepartmentType();
                        Assert.notNull(departmentType, "departmentType不能为空！");
                        BdDeptdocEntity bdDeptdocEntity = new BdDeptdocEntity();
                        bdDeptdocEntity.setDataSourceCode("lets_u8c");
                        bdDeptdocEntity.setDr(0);
                        bdDeptdocEntity.setDeptcode(departmentType.trim());
                        bdDeptdocEntity.setPkCorp(bdCorpEntityList.get(0).getPkCorp());
                        bdDeptdocEntityList = iBdDeptdocDao.query(bdDeptdocEntity);
                        if (bdDeptdocEntityList.size() == 0) {
                            Assert.state(false, "指定部门：根据部门编码：{} 公司id：{}，无法匹配到U8C销售组织", header2.getDepartmentType(), bdCorpEntityList.get(0).getPkCorp());
                        } else if (bdDeptdocEntityList.size() >= 2) {
                            Assert.state(false, "指定部门：根据部门编码：{} 公司id：{}，匹配到U8C销售组织{}个", header2.getDepartmentType(), bdCorpEntityList.get(0).getPkCorp());
                        }
                    }

                    //客商基本档案
//                    String custName = "天猫intoyou旗舰店-自营";
//                    BdCubasdocEntity bdCubasdocEntity = new BdCubasdocEntity();
//                    bdCubasdocEntity.setDataSourceCode("lets_u8c");
//                    bdCubasdocEntity.setDr(0L);
//                    bdCubasdocEntity.setDef1(memberId.trim());
//                    List<BdCubasdocEntity> bdCubasdocEntityList = iBdCubasdocDao.query(bdCubasdocEntity);
//                    if (bdCubasdocEntityList == null || bdCubasdocEntityList.size() == 0) {
//                        Assert.state(false, "根据OFS会员id{}，无法查询到U8C客商基本档案", memberId);
//                    } else if (bdCubasdocEntityList.size() >= 2) {
//                        Assert.state(false, "根据OFS会员id{}，无法查询到U8C客商基本档案", memberId);
//                    }
                    BdCubasdocEntity fuzzyQueryCustomers = queryU8CEntityUtil.getFuzzyQueryCustomers(memberId.trim());
                    Assert.notNull(fuzzyQueryCustomers, "根据OFS会员id：{}，无法查询到U8C客商基本档案", memberId.trim());

                    //客商管理档案
                    BdCumandocEntity bdCumandocEntity1 = new BdCumandocEntity();
                    bdCumandocEntity1.setDataSourceCode("lets_u8c");
                    bdCumandocEntity1.setDr(0L);
                    bdCumandocEntity1.setPkCorp(bdCorpEntityList.get(0).getPkCorp());
                    bdCumandocEntity1.setPkCubasdoc(fuzzyQueryCustomers.getPkCubasdoc());
                    bdCumandocEntity1.setCustflags(ProfilesActiveConstant.CUSTOMER);
                    List<BdCumandocEntity> bdCumandocEntityList = iBdCumandocDao.query(bdCumandocEntity1);
                    if (bdCumandocEntityList == null || bdCumandocEntityList.size() == 0) {
                        Assert.state(false, "根据客商基本档案主键{} 客商名称：{}，无法匹配到公司：{} 对应的客商管理档案", fuzzyQueryCustomers.getPkCubasdoc(), fuzzyQueryCustomers.getCustname(), bdCorpEntityList.get(0).getUnitname());
                    }

                    //查找平台
//                    String platformZdyId = "0001A210000000000JUD";
                    String platformZdyId = OverallConstant.getOverAllValue("u8c自定义项档案-平台主键");
                    String sourcePlatformCode = ofsRertunOrder.getHeader().getSourcePlatformCode();
                    Assert.notNull(sourcePlatformCode, "sourcePlatformCode不能为空");
                    BdDefdocEntity bdDefdocEntity = new BdDefdocEntity();
                    bdDefdocEntity.setPkDefdoclist(platformZdyId);
//                    bdDefdocEntity.setDr(0);
                    bdDefdocEntity.setDataSourceCode("lets_u8c");
                    bdDefdocEntity.setDoccode(sourcePlatformCode.trim());
                    List<BdDefdocEntity> bdDefdocEntityList = iBdDefdocDao.query(bdDefdocEntity);
                    if (bdDefdocEntityList.size() == 0) {
                        Assert.state(false, "根据O平台编码{}，无法匹配到U8C平台自定义档案 自定义档案主键:{}", sourcePlatformCode, platformZdyId);
                    } else if (bdDefdocEntityList.size() >= 2) {
                        Assert.state(false, "根据O平台编码{}，无法匹配到U8C平台自定义档案 自定义档案主键:{}", sourcePlatformCode, platformZdyId);
                    }

                    //查询U8C店铺档案
//                    String platformZdyId2 = "0001A210000000000XZX";
                    String platformZdyId2 = OverallConstant.getOverAllValue("u8c自定义项档案-店铺主键");
                    String ofsStoreCode = header.getStoreCode();
                    Assert.notNull(ofsStoreCode, "ofsStoreCode不能为空");
                    BdDefdocEntity bdDefdocEntity2 = new BdDefdocEntity();
                    bdDefdocEntity2.setPkDefdoclist(platformZdyId2);
//                    bdDefdocEntity2.setDr(0);
                    bdDefdocEntity2.setDataSourceCode("lets_u8c");
                    bdDefdocEntity2.setDoccode(ofsStoreCode.trim());
                    List<BdDefdocEntity> bdDefdocEntityList2 = iBdDefdocDao.query(bdDefdocEntity2);
                    if (bdDefdocEntityList2.size() == 0) {
                        Assert.state(false, "根据O店铺编码{}，无法匹配到U8C店铺自定义档案 自定义档案主键:{}", ofsStoreCode, platformZdyId);
                    } else if (bdDefdocEntityList2.size() >= 2) {
                        Assert.state(false, "根据O店铺编码{}，无法匹配到U8C店铺自定义档案 自定义档案主键:{}", ofsStoreCode, platformZdyId);
                    }

                    OrderToBHeaderDtoV2 orderOutTobHeaderDto = new OrderToBHeaderDtoV2();
                    orderOutTobHeaderDto.setBdCorpEntity(bdCorpEntityList.get(0));
                    orderOutTobHeaderDto.setBdCalbodyEntity(bdCalbodyEntities.get(0));
                    orderOutTobHeaderDto.setBdStordocEntity(bdStordocEntityList.get(0));
                    orderOutTobHeaderDto.setBdSalestruEntity(bdSalestruEntityList.get(0));
                    orderOutTobHeaderDto.setBdDeptdocEntity(bdDeptdocEntityList.get(0));
                    orderOutTobHeaderDto.setBdCumandocEntity(bdCumandocEntityList.get(0));
                    orderOutTobHeaderDto.setBdCubasdocEntity(fuzzyQueryCustomers);
                    orderOutTobHeaderDto.setDeliverGoodsCorp(bdCorpEntityList.get(0));
                    orderOutTobHeaderDto.setPlatformArchives(bdDefdocEntityList.get(0));
                    orderOutTobHeaderDto.setShopArchives(bdDefdocEntityList2.get(0));
                    orderOutTobHeaderDto.setSaleOrderMessageDto(saleOrderMessageDto);
                    orderOutTobHeaderDto.setOfsRertunOrder(ofsRertunOrder);
                    orderOutTobHeaderDto.setBdRdclEntity(bdRdclEntity);

                    orderOutTobHeaderDto.setHeader(header);
                    orderOutTobHeaderDto.setDetails(details);

                    orderToBHeaderDtoArrayList.add(orderOutTobHeaderDto);
                } catch (Exception e) {
                    logger.error("档案转换失败", e);
                    //失败
                    String message = e.getMessage();
                    if (message == null) {
                        message = "未知错误";
                    }
                    ErrorHeaderDetailsDtoDtoV3 errorHeaderDetailsDtoDto = new ErrorHeaderDetailsDtoDtoV3();
                    errorHeaderDetailsDtoDto.setNewPushDate(getNewDateStr());
                    errorHeaderDetailsDtoDto.setNewTransmitInfo(message);
                    errorHeaderDetailsDtoDto.setNewstate("N");
                    errorHeaderDetailsDtoDto.setHeader(header);
                    errorHeaderDetailsDtoDto.setDetails(details);
                    errorHeaderDetailsDtoDtoList.add(errorHeaderDetailsDtoDto);
                }
            }
            //档案转换成功
        } else {
            logger.info("queryBasicArchives方法对应的returnGoodHeaderDetailsDataDtoList.size为0");
        }
        if (errorHeaderDetailsDtoDtoList.size() > 0) {
            updateFailOrSuccessTocofsSaleoutDetailedArchiveInquiryStock(errorHeaderDetailsDtoDtoList, sceneType);
        }
        return orderToBHeaderDtoArrayList;
    }

    /**
     * 交易成功档案查询，档案转换
     *
     * @param passiveStorageList O无源入库单¬
     * @author liuyang
     */
    private List<OrderToBHeaderDtoV2> queryBasicArchivesTran(List<PassiveStorageResponse.Data> passiveStorageList, String sceneType) throws Exception {
        if (passiveStorageList != null) {
            logger.info("确认收入：需要把OFS档案转换为U8C档案的O数据条数：{}", passiveStorageList.size());
        }
        List<OrderToBHeaderDtoV2> orderToBHeaderDtoArrayList = new ArrayList<>();
        List<ErrorHeaderDetailsDtoDtoV3> errorHeaderDetailsDtoDtoList = new ArrayList<>();

        if (passiveStorageList != null && passiveStorageList.size() > 0) {
            for (int i = 0; i < passiveStorageList.size(); i++) {
                PassiveStorageResponse.Data data = passiveStorageList.get(i);
                PassiveStorageResponse.Header header = data.getHeader();
                List<PassiveStorageResponse.Details> details = data.getDetails();

                try {
//                    Assert.state(false, "测试");
                    //查询OFS售后订单
                    Assert.notNull(header.getReturnOrderCode(), "header.getReturnOrderCode()不能为空！");
                    RerturnGoodsOrderSearchData ofsRertunOrder = afterSalesOrderUtil.getOfsRertunOrder(header.getReturnOrderCode().trim());
                    Assert.notNull(ofsRertunOrder, "无法查询到OFS售后订单 单据编码：{}", header.getReturnOrderCode());
                    //2025-03-17 16:41:14 过滤掉不存在交易成功时间的无源入库单
//                    ofsRertunOrder.getHeader().setRefundedAt("2025-03-15 11:57:06");
                    if (ofsRertunOrder.getHeader() == null || ofsRertunOrder.getHeader().getRefundedAt() == null || "".equals(ofsRertunOrder.getHeader().getRefundedAt().trim())) {
                        Assert.state(false, "当前无源入库单对应的售后订单没有退款完成时间!");
                    }

                    //查询OFS销售订单
                    SaleOrderMessageDto saleOrderMessageDto = null;
                    try {
                        Assert.notNull(ofsRertunOrder.getHeader(), "ofsRertunOrder.getHeader()不能为空");
                        Assert.notNull(ofsRertunOrder.getHeader().getRefOrderCode(), "ofsRertunOrder.getHeader().getRefOrderCode()不能为空");
                        saleOrderMessageDto = afterSalesOrderUtil.getOfsOrder(ofsRertunOrder.getHeader().getRefOrderCode().trim());
                    } catch (Exception e) {
                        logger.error("查询出售后订单错误，失败原因：{}", e.getMessage());
                        Assert.state(false, "查询出售后订单错误，失败原因：{}", e.getMessage());
                    }
                    List<HeaderDetailsDto> headerDetailsDtoList = saleOrderMessageDto.getData();
                    if (headerDetailsDtoList == null || headerDetailsDtoList.size() == 0) {
                        Assert.state(false, "无法匹配到OFS销售订单 售后订单号：{}", ofsRertunOrder.getHeader().getCode());
                    }
                    HeaderDetailsDto headerDetailsDto = headerDetailsDtoList.get(0);
                    HeaderDto header2 = headerDetailsDto.getHeader();
                    List<DetailsDto> details1 = headerDetailsDto.getDetails();

                    if (saleOrderMessageDto == null) {
                        Assert.state(false, "没有匹配到售后订单，系统业务无法完成");
                    }
                    HeaderDto header1 = saleOrderMessageDto.getData().get(0).getHeader();
                    String memberId = header1.getMemberId();
//                    memberId = "GYS00002";
                    Assert.notNull(memberId, "TOB销售订单(OFS)表头会员id不能为空，否则无法匹配U8C客商档案！");
                    Assert.state(!"".equals(memberId.trim()), "TOB销售订单(OFS)表头会员id不能为空，否则无法匹配U8C客商档案！");

                    //查询对应的收发类别
                    if (header1.getSubOrderType() == null || "".equals(header1.getSubOrderType().trim())) {
                        header1.setSubOrderType("SALES");
                    }
                    BdRdclEntity bdRdclEntity = rdclUtil.queryRdClObject(header1.getSubOrderType().trim());
                    Assert.notNull(bdRdclEntity, "根据收发类别编码：{} 无法匹配到U8C收发类别");

                    //2024年8月30日 10:57:29 查询对应的U8C销售订单，注意要把编码和主键一起查询，O主键导入到U8C中，对于U8C来说可能会重复
                    Assert.notNull(header.getReceiptCode(), "header.getCode()不能为空");
                    Assert.notNull(header.getId(), "header.getId()不能为空");
                    SoSaleEntity soSaleEntity = new SoSaleEntity();
                    soSaleEntity.setDr(0L);
                    soSaleEntity.setDataSourceCode("lets_u8c");
                    soSaleEntity.setVdef19(header.getReceiptCode().trim());
                    soSaleEntity.setVdef20(header.getId().trim());
                    soSaleEntity.setBretinvflag("Y");//仅查询红字销售订单
                    List<SoSaleEntity> soSaleEntityList = iSoSaleDao.query(soSaleEntity);
                    if (soSaleEntityList == null || soSaleEntityList.size() == 0) {
                        Assert.state(false, "根据O无源入库单主键：{} 单号：{} 无法匹配到U8C红字销售订单(传到U8C可能失败了！bretinvflag=Y)", header.getId(), header.getReceiptCode());
                    } else if (soSaleEntityList.size() >= 2) {
                        Assert.state(false, "根据O无源入库单主键：{} 单号：{} 匹配到{}个U8C红字销售订单，存在歧义！", header.getId(), header.getReceiptCode(), soSaleEntityList.size());
                    }

                    //查询销售订单明细行表体
                    SoSaleorderBEntity soSaleorderBEntity = new SoSaleorderBEntity();
                    soSaleorderBEntity.setDr(0L);
                    soSaleorderBEntity.setCsaleid(soSaleEntityList.get(soSaleEntityList.size() - 1).getCsaleid());
                    soSaleorderBEntity.setDataSourceCode("lets_u8c");
                    List<SoSaleorderBEntity> soSaleorderBEntityList = iSoSaleorderBDao.query(soSaleorderBEntity);
                    if (soSaleorderBEntityList == null || soSaleorderBEntityList.size() == 0) {
                        Assert.state(false, "根据O销售订单主键：{}，无法匹配到U8C销售订单明细行(传到U8C可能失败了！)", soSaleEntityList.get(soSaleEntityList.size() - 1).getCsaleid());
                    }

                    //查询U8C销售订单对应的销售出库单表头
                    IcGeneralHEntity icGeneralHEntity = new IcGeneralHEntity();
                    icGeneralHEntity.setCsourcebillhid(soSaleEntityList.get(soSaleEntityList.size() - 1).getCsaleid());
                    icGeneralHEntity.setDr(0);
                    icGeneralHEntity.setDataSourceCode("lets_u8c");
                    List<IcGeneralHEntity> icGeneralHEntityList = iIcGeneralHDao.query(icGeneralHEntity);
                    if (icGeneralHEntityList == null || icGeneralHEntityList.size() == 0) {
                        Assert.state(false, "根据U8C销售订单表头id:{}，无法查询到销售出库单", soSaleEntityList.get(soSaleEntityList.size() - 1).getCsaleid());
                    } else if (icGeneralHEntityList.size() >= 2) {
                        Assert.state(false, "根据U8C销售订单表头id:{}，查询到{}个销售出库单", soSaleEntityList.get(soSaleEntityList.size() - 1).getCsaleid(), icGeneralHEntityList.size());
                    }

                    //查询U8C销售订单对应的销售出库单表体
                    IcGeneralBEntity icGeneralBEntity = new IcGeneralBEntity();
                    icGeneralBEntity.setCsourcebillhid(soSaleEntityList.get(soSaleEntityList.size() - 1).getCsaleid());
                    icGeneralBEntity.setDr(0);
                    icGeneralBEntity.setDataSourceCode("lets_u8c");
                    List<IcGeneralBEntity> icGeneralBEntityList = iIcGeneralBDao.query(icGeneralBEntity);
                    if (icGeneralBEntityList == null || icGeneralBEntityList.size() == 0) {
                        Assert.state(false, "根据U8C销售订单表头id:{}，无法查询到销售出库单明细行", soSaleEntityList.get(soSaleEntityList.size() - 1).getCsaleid());
                    }

                    //2024年8月30日 11:09:32 查询U8C销售订单执行情况明细表，主要是带出U8C销售订单表体的自定义项
                    SoSaleorderBEntity soSaleorderBEntity1 = new SoSaleorderBEntity();
                    soSaleorderBEntity1.setCsaleid(soSaleEntityList.get(soSaleEntityList.size() - 1).getCsaleid());
                    List<ExtIntegrationTaskLivingDetailsQueryVo> extIntegrationTaskLivingDetailsQueryVos = iSoSaleorderBDao.queryErrorDetailsId(soSaleorderBEntity1);
                    if (extIntegrationTaskLivingDetailsQueryVos == null || extIntegrationTaskLivingDetailsQueryVos.size() == 0) {
                        Assert.state(false, "根据销售订单主键：{}，无法匹配到销售订单执行情况明细");
                    }

                    // 销售公司、发货公司
                    String companyCode = header.getCompanyCode();
                    Assert.notNull(companyCode, "O表头公司不能为空");
                    String replaceCompanyCode = queryU8CEntityUtil.queryBdDefDocByPkDefDocList(companyCode.trim());
                    Assert.notNull(replaceCompanyCode, "replaceCompanyCode不能为空！");

                    BdCorpEntity bdCorpEntity = new BdCorpEntity();
                    bdCorpEntity.setDr(0);
                    bdCorpEntity.setDataSourceCode("lets_u8c");
                    bdCorpEntity.setUnitcode(replaceCompanyCode);
                    List<BdCorpEntity> bdCorpEntityList = iBdCorpDao.query(bdCorpEntity);
                    if (bdCorpEntityList.size() == 0) {
                        Assert.state(false, "根据O货主编码{}，无法匹配到U8C销售公司", replaceCompanyCode);
                    } else if (bdCorpEntityList.size() >= 2) {
                        Assert.state(false, "根据O货主编码{}，匹配到U8C销售公司{}个", replaceCompanyCode, bdCorpEntityList.size());
                    }

                    // 发货库存组织
                    BdCalbodyEntity bdCalbodyEntity = new BdCalbodyEntity();
                    bdCalbodyEntity.setDr(0);
                    bdCalbodyEntity.setDataSourceCode("lets_u8c");
                    bdCalbodyEntity.setPkCorp(bdCorpEntityList.get(0).getPkCorp());
                    List<BdCalbodyEntity> bdCalbodyEntities = iBdCalbodyDao.query(bdCalbodyEntity);
                    if (bdCalbodyEntities.size() == 0) {
                        Assert.state(false, "根据U8C发货公司{}，无法匹配到U8C发货库存组织", bdCorpEntityList.get(0).getPkCorp());
                    } else if (bdCalbodyEntities.size() >= 2) {
                        Assert.state(false, "根据U8C发货公司{}，匹配到U8C发货库存组织{}个", bdCorpEntityList.get(0).getPkCorp(), bdCalbodyEntities.size());
                    }

                    // 仓库
                    String facilityCode = header.getFacilityCode();
                    Assert.notNull(facilityCode, "O售后入库单仓库facilityCode字段不能为空");
                    BdStordocEntity bdStordocEntity = new BdStordocEntity();
                    bdStordocEntity.setDr(0L);
                    bdStordocEntity.setDataSourceCode("lets_u8c");
                    bdStordocEntity.setPkCalbody(bdCalbodyEntities.get(0).getPkCalbody());
                    bdStordocEntity.setStorcode(facilityCode.trim());
                    List<BdStordocEntity> bdStordocEntityList = iBdStordocDao.query(bdStordocEntity);
                    if (bdStordocEntityList.size() == 0) {
                        Assert.state(false, "根据O仓库编码+U8C发货库存组织主键，无法匹配到U8C仓库", facilityCode, bdCalbodyEntities.get(0).getPkCalbody());
                    } else if (bdStordocEntityList.size() >= 2) {
                        Assert.state(false, "根据O仓库编码+U8C发货库存组织主键，匹配到U8C仓库多个", facilityCode, bdCalbodyEntities.get(0).getPkCalbody());
                    }

                    //销售组织
                    //2024年8月13日 10:35:05 已经和佳妮在微信确认，U8C销售公司编码与U8C销售组织编码保持一致，因此通过销售公司编码匹配
                    BdSalestruEntity bdSalestruEntity = new BdSalestruEntity();
                    bdSalestruEntity.setDr(0);
                    bdSalestruEntity.setDataSourceCode("lets_u8c");
                    bdSalestruEntity.setVsalestrucode(bdCorpEntityList.get(0).getUnitcode());
                    List<BdSalestruEntity> bdSalestruEntityList = iBdSalestruDao.query(bdSalestruEntity);
                    if (bdSalestruEntityList.size() == 0) {
                        Assert.state(false, "根据U8C销售公司编码：{}，无法匹配到U8C销售组织", bdCorpEntityList.get(0).getUnitcode());
                    } else if (bdSalestruEntityList.size() >= 2) {
                        Assert.state(false, "根据U8C销售公司编码：{}，无法匹配到U8C销售组织", bdCorpEntityList.get(0).getUnitcode());
                    }

                    //业务部门
                    //2024年8月14日 10:38:37 已经和佳妮确认
                    List<BdDeptdocEntity> bdDeptdocEntityList = null;
                    if (header2.getDepartmentType() == null || "".equals(header2.getDepartmentType().trim())) {
                        logger.info("OFS销售订单号：{} 不存在部门字段！", header2.getCode());
                        String deptName = "业务部门";
                        BdDeptdocEntity bdDeptdocEntity = new BdDeptdocEntity();
                        bdDeptdocEntity.setDataSourceCode("lets_u8c");
                        bdDeptdocEntity.setDr(0);
                        bdDeptdocEntity.setDeptname(deptName);
                        bdDeptdocEntity.setPkCorp(bdCorpEntityList.get(0).getPkCorp());
                        bdDeptdocEntityList = iBdDeptdocDao.query(bdDeptdocEntity);
                        if (bdDeptdocEntityList.size() == 0) {
                            Assert.state(false, "根据部门名称：{} 公司id：{}，无法匹配到U8C销售组织", deptName, bdCorpEntityList.get(0).getPkCorp());
                        } else if (bdDeptdocEntityList.size() >= 2) {
                            Assert.state(false, "根据部门名称：{} 公司id：{}，匹配到U8C销售组织{}个", deptName, bdCorpEntityList.get(0).getPkCorp());
                        }
                    } else {
                        logger.info("OFS销售订单号：{} 存在部门字段：{}！", header2.getCode(), header2.getDepartmentType());
                        String departmentType = header2.getDepartmentType();
                        BdDeptdocEntity bdDeptdocEntity = new BdDeptdocEntity();
                        bdDeptdocEntity.setDataSourceCode("lets_u8c");
                        bdDeptdocEntity.setDr(0);
                        bdDeptdocEntity.setDeptcode(departmentType.trim());
                        bdDeptdocEntity.setPkCorp(bdCorpEntityList.get(0).getPkCorp());
                        bdDeptdocEntityList = iBdDeptdocDao.query(bdDeptdocEntity);
                        if (bdDeptdocEntityList.size() == 0) {
                            Assert.state(false, "指定部门：根据部门编码：{} 公司id：{}，无法匹配到U8C销售组织", header2.getDepartmentType(), bdCorpEntityList.get(0).getPkCorp());
                        } else if (bdDeptdocEntityList.size() >= 2) {
                            Assert.state(false, "指定部门：根据部门编码：{} 公司id：{}，匹配到U8C销售组织{}个", header2.getDepartmentType(), bdCorpEntityList.get(0).getPkCorp());
                        }
                    }

                    //客商基本档案
//                    BdCubasdocEntity bdCubasdocEntity = new BdCubasdocEntity();
//                    bdCubasdocEntity.setDataSourceCode("lets_u8c");
//                    bdCubasdocEntity.setDr(0L);
//                    bdCubasdocEntity.setDef1(memberId.trim());
//                    List<BdCubasdocEntity> bdCubasdocEntityList = iBdCubasdocDao.query(bdCubasdocEntity);
//                    if (bdCubasdocEntityList == null || bdCubasdocEntityList.size() == 0) {
//                        Assert.state(false, "根据OFS会员id{}，无法查询到U8C客商基本档案", memberId);
//                    } else if (bdCubasdocEntityList.size() >= 2) {
//                        Assert.state(false, "根据OFS会员id{}，无法查询到U8C客商基本档案", memberId);
//                    }
                    BdCubasdocEntity fuzzyQueryCustomers = queryU8CEntityUtil.getFuzzyQueryCustomers(memberId.trim());
                    Assert.notNull(fuzzyQueryCustomers, "根据OFS会员id：{}，无法查询到U8C客商基本档案", memberId.trim());

                    //客商管理档案
                    BdCumandocEntity bdCumandocEntity1 = new BdCumandocEntity();
                    bdCumandocEntity1.setDataSourceCode("lets_u8c");
                    bdCumandocEntity1.setDr(0L);
                    bdCumandocEntity1.setPkCorp(bdCorpEntityList.get(0).getPkCorp());
                    bdCumandocEntity1.setPkCubasdoc(fuzzyQueryCustomers.getPkCubasdoc());
                    bdCumandocEntity1.setCustflags(ProfilesActiveConstant.CUSTOMER);
                    List<BdCumandocEntity> bdCumandocEntityList = iBdCumandocDao.query(bdCumandocEntity1);
                    if (bdCumandocEntityList == null || bdCumandocEntityList.size() == 0) {
                        Assert.state(false, "根据客商基本档案主键{} 客商名称：{}，无法匹配到公司：{} 对应的客商管理档案", fuzzyQueryCustomers.getPkCubasdoc(), fuzzyQueryCustomers.getCustname(), bdCorpEntityList.get(0).getUnitname());
                    }

                    //查找平台
//                    String platformZdyId = "0001A210000000000JUD";
                    String platformZdyId = OverallConstant.getOverAllValue("u8c自定义项档案-平台主键");
                    String sourcePlatformCode = ofsRertunOrder.getHeader().getSourcePlatformCode();
                    Assert.notNull(sourcePlatformCode, "sourcePlatformCode不能为空！");
                    BdDefdocEntity bdDefdocEntity = new BdDefdocEntity();
                    bdDefdocEntity.setPkDefdoclist(platformZdyId);
//                    bdDefdocEntity.setDr(0);
                    bdDefdocEntity.setDataSourceCode("lets_u8c");
                    bdDefdocEntity.setDoccode(sourcePlatformCode.trim());
                    List<BdDefdocEntity> bdDefdocEntityList = iBdDefdocDao.query(bdDefdocEntity);
                    if (bdDefdocEntityList.size() == 0) {
                        Assert.state(false, "根据O平台编码{}，无法匹配到U8C平台自定义档案 自定义档案主键:{}", sourcePlatformCode, platformZdyId);
                    } else if (bdDefdocEntityList.size() >= 2) {
                        Assert.state(false, "根据O平台编码{}，无法匹配到U8C平台自定义档案 自定义档案主键:{}", sourcePlatformCode, platformZdyId);
                    }

                    //查询U8C店铺档案
//                    String platformZdyId2 = "0001A210000000000XZX";
                    String platformZdyId2 = OverallConstant.getOverAllValue("u8c自定义项档案-店铺主键");
                    String ofsStoreCode = header.getStoreCode();
                    Assert.notNull(ofsStoreCode, "ofsStoreCode不能为空");
                    BdDefdocEntity bdDefdocEntity2 = new BdDefdocEntity();
                    bdDefdocEntity2.setPkDefdoclist(platformZdyId2);
//                    bdDefdocEntity2.setDr(0);
                    bdDefdocEntity2.setDataSourceCode("lets_u8c");
                    bdDefdocEntity2.setDoccode(ofsStoreCode.trim());
                    List<BdDefdocEntity> bdDefdocEntityList2 = iBdDefdocDao.query(bdDefdocEntity2);
                    if (bdDefdocEntityList2.size() == 0) {
                        Assert.state(false, "根据O店铺编码{}，无法匹配到U8C店铺自定义档案 自定义档案主键:{}", ofsStoreCode, platformZdyId);
                    } else if (bdDefdocEntityList2.size() >= 2) {
                        Assert.state(false, "根据O店铺编码{}，无法匹配到U8C店铺自定义档案 自定义档案主键:{}", ofsStoreCode, platformZdyId);
                    }

                    //2024年8月28日 11:01:07 查询对应的U8C销售订单
//                    SoSaleEntity soSaleEntity = new SoSaleEntity();
//                    soSaleEntity.setDr(0L);
//                    soSaleEntity.setDataSourceCode("lets_u8c");
//                    soSaleEntity.setVdef19(header.getCode());
//                    soSaleEntity.setVdef20(header.getId());
//                    List<SoSaleEntity> soSaleEntityList = iSoSaleDao.query(soSaleEntity);
//                    if (soSaleEntityList == null || soSaleEntityList.size() == 0) {
//                        Assert.state(false, "根据O出库单主键：{} 单号：{} 无法匹配到U8C销售订单(传到U8C可能失败了！)", header.getId(), header.getCode());
//                    } else if (soSaleEntityList.size() >= 2) {
//                        Assert.state(false, "根据O出库单主键：{} 单号：{} 匹配到{}个U8C销售订单", header.getId(), header.getCode(), soSaleEntityList.size());
//                    }

                    OrderToBHeaderDtoV2 orderOutTobHeaderDto = new OrderToBHeaderDtoV2();
                    orderOutTobHeaderDto.setBdCorpEntity(bdCorpEntityList.get(0));
                    orderOutTobHeaderDto.setBdCalbodyEntity(bdCalbodyEntities.get(0));
                    orderOutTobHeaderDto.setBdStordocEntity(bdStordocEntityList.get(0));
                    orderOutTobHeaderDto.setBdSalestruEntity(bdSalestruEntityList.get(0));
                    orderOutTobHeaderDto.setBdDeptdocEntity(bdDeptdocEntityList.get(0));
                    orderOutTobHeaderDto.setBdCumandocEntity(bdCumandocEntityList.get(0));
                    orderOutTobHeaderDto.setBdCubasdocEntity(fuzzyQueryCustomers);
                    orderOutTobHeaderDto.setDeliverGoodsCorp(bdCorpEntityList.get(0));
                    orderOutTobHeaderDto.setPlatformArchives(bdDefdocEntityList.get(0));
                    orderOutTobHeaderDto.setShopArchives(bdDefdocEntityList2.get(0));
                    orderOutTobHeaderDto.setSaleOrderMessageDto(saleOrderMessageDto);
                    orderOutTobHeaderDto.setSoSaleEntity(soSaleEntityList.get(0));
                    orderOutTobHeaderDto.setIcGeneralHEntity(icGeneralHEntityList.get(0));
                    orderOutTobHeaderDto.setIcGeneralBEntityList(icGeneralBEntityList);
                    orderOutTobHeaderDto.setSoSaleorderBEntityList(soSaleorderBEntityList);
                    orderOutTobHeaderDto.setExtIntegrationTaskLivingDetailsQueryVos(extIntegrationTaskLivingDetailsQueryVos);
                    orderOutTobHeaderDto.setOfsRertunOrder(ofsRertunOrder);
                    orderOutTobHeaderDto.setBdRdclEntity(bdRdclEntity);

                    orderOutTobHeaderDto.setHeader(header);
                    orderOutTobHeaderDto.setDetails(details);

                    BeanUtil.copyPropertiesV2(header, orderOutTobHeaderDto);
                    orderToBHeaderDtoArrayList.add(orderOutTobHeaderDto);
                } catch (Exception e) {
                    logger.error("TOB无源退货确认收入", e);
                    //失败
                    String message = e.getMessage();
                    if (message == null) {
                        message = "未知错误";
                    }
                    ErrorHeaderDetailsDtoDtoV3 errorHeaderDetailsDtoDto = new ErrorHeaderDetailsDtoDtoV3();
                    errorHeaderDetailsDtoDto.setNewPushDate(getNewDateStr());
                    errorHeaderDetailsDtoDto.setNewTransmitInfo(message);
                    errorHeaderDetailsDtoDto.setNewstate("N");
                    errorHeaderDetailsDtoDto.setHeader(header);
                    errorHeaderDetailsDtoDto.setDetails(details);
                    errorHeaderDetailsDtoDtoList.add(errorHeaderDetailsDtoDto);
                }
            }
        } else {
            logger.info("queryBasicArchives方法对应的returnGoodHeaderDetailsDataDtoList.size为0");
        }
        if (errorHeaderDetailsDtoDtoList.size() > 0) {
            updateFailOrSuccessTocofsSaleoutDetailedArchiveInquiryStock(errorHeaderDetailsDtoDtoList, sceneType);
        }
        return orderToBHeaderDtoArrayList;
    }

    /**
     * 对象拷贝 bean copy
     * 2024年8月9日 11:23:57
     */
    private List<OfsPassiveorderHeaderEntity> copyHeaderDto(List<PassiveStorageResponse.Header> stockinHS) {
        List<OfsPassiveorderHeaderEntity> ofsPassiveorderHeaderEntityArrayList = new ArrayList<>();
        if (stockinHS != null && stockinHS.size() > 0) {
            for (int i = 0; i < stockinHS.size(); i++) {
                PassiveStorageResponse.Header header = stockinHS.get(i);

                OfsPassiveorderHeaderEntity ofsPassiveorderHeaderEntity = new OfsPassiveorderHeaderEntity();
                BeanUtil.copyPropertiesV2(header, ofsPassiveorderHeaderEntity);
                ofsPassiveorderHeaderEntityArrayList.add(ofsPassiveorderHeaderEntity);
            }
        } else {
            logger.info("需要复制{}个bean对象(O表头)", stockinHS.size());
        }
        return ofsPassiveorderHeaderEntityArrayList;
    }

    /**
     * 对象拷贝 bean copy
     *
     * @author liuyang
     */
    private List<OfsPassiveorderDetailEntity> copyDetailsDto(List<PassiveStorageResponse.Details> stockinBS) {
        List<OfsPassiveorderDetailEntity> ofsPassiveorderDetailEntityArrayList = new ArrayList<>();
        if (stockinBS != null && stockinBS.size() > 0) {
            for (int i = 0; i < stockinBS.size(); i++) {
                PassiveStorageResponse.Details details = stockinBS.get(i);
                //表头
                PassiveStorageResponse.Header header = details.getHeader();
                //拷贝对象
                OfsPassiveorderDetailEntity tocofsReturngoodsDetailedEntity = new OfsPassiveorderDetailEntity();
                BeanUtil.copyPropertiesV2(details, tocofsReturngoodsDetailedEntity);
                //补充额外的字段信息
                createPrimaryKeyAndBusinessDateAndBusinessType(tocofsReturngoodsDetailedEntity, header);
                ofsPassiveorderDetailEntityArrayList.add(tocofsReturngoodsDetailedEntity);
            }
        } else {
            logger.info("需要复制{}个bean对象(O表体)", ofsPassiveorderDetailEntityArrayList.size());
        }
        return ofsPassiveorderDetailEntityArrayList;
    }

    /**
     * 2024年8月6日 10:59:03 查询U8C业务流程
     *
     * @author liuyang
     */
    private BdBusitypeEntity u8cOperationFlow() throws Exception {
        //查询业务流程
        //2024年8月6日 11:33:07 具体的业务流程名称，还需要实施提供
        String processName = "TOB无源件";
        BdBusitypeEntity bdBusitypeEntity = queryBdBusitypeUtil.queryBdBusitype(processName);
        Assert.notNull(bdBusitypeEntity, "根据业务流程名称({})没有查询到业务流程", processName);
        return bdBusitypeEntity;
    }

    /**
     * 查询存货管理档案
     *
     * @param pkCorp     发货公司主键
     * @param detailsDto 出库单存货明细行
     * @author liuyang
     */
    private BdInvmandocEntity queryInventoryMan(PassiveStorageResponse.Details detailsDto, String pkCorp) throws Exception {
        Assert.notNull(detailsDto, "sonDetailsDto不能为空");
        Assert.notNull(detailsDto.getSkuCode(), "O存货商家编码不能为空");
        Assert.notNull(pkCorp, "发货公司主键不能为空");

        BdInvmandocEntity bdInvmandocEntity = new BdInvmandocEntity();
        bdInvmandocEntity.setInvcode(detailsDto.getSkuCode());
        bdInvmandocEntity.setPkCorp(pkCorp);
        List<BdInvmandocEntity> bdInvmandocEntity2 = iBdInvmandocDao.queryBdInvmandocByInvcodeList(bdInvmandocEntity);
        if (bdInvmandocEntity2.size() == 0) {
            Assert.state(false, "根据O商家编码：{} U8C发货公司主键：{}没有查询到存货管理档案", detailsDto.getSkuCode(), pkCorp);
        } else if (bdInvmandocEntity2.size() >= 2) {
            Assert.state(false, "根据O商家编码：{} U8C发货公司主键：{}没有查询到存货管理档案", detailsDto.getSkuCode(), pkCorp);
        }
        return bdInvmandocEntity2.get(0);
    }

    /**
     * 2024年8月7日 10:25:29
     * 查询基础档案，根据公司、管理档案主键查询
     *
     * @author liuyang
     */
    private BdInvbasdocEntity queryStockBasicArchives(String pkInvmandoc, String pkCorp) throws Exception {
        Assert.notNull(pkInvmandoc, "存货管理档案不能为空");
        Assert.notNull(pkCorp, "公司档案不能为空");

        BdInvbasdocEntity bdInvbasdocEntity = new BdInvbasdocEntity();
        bdInvbasdocEntity.setPk_invmandoc(pkInvmandoc);
        bdInvbasdocEntity.setPk_corp(pkCorp);
        List<BdInvbasdocEntity> bdInvbasdocEntity2 = iBdInvbasdocDao.queryBdInvbasdocByPkInvmandocV2(bdInvbasdocEntity);
        if (bdInvbasdocEntity2.size() == 0) {
            Assert.state(false, "根据存货管理档案主键{}和公司档案主键{}没有查询到U8C基础档案", pkInvmandoc, pkCorp);
        } else if (bdInvbasdocEntity2.size() >= 2) {
            Assert.state(false, "根据存货管理档案主键{}和公司档案主键{}没有查询到U8C基础档案", pkInvmandoc, pkCorp);
        }
        return bdInvbasdocEntity2.get(0);
    }

    /**
     * 2024年8月7日 14:58:34
     * 查询税目档案
     *
     * @author liuyang
     */
    private BdTaxitemsEntity queryBdTaxitems(String invcode) throws Exception {
        Assert.notNull(invcode, "存货编码不能为空");

        BdTaxitemsEntity bdTaxitemsEntity = new BdTaxitemsEntity();
        bdTaxitemsEntity.setInvcode(invcode);
        List<BdTaxitemsEntity> bdTaxitemsEntityList = iBdTaxitemsDao.queryBdInvbasdocByInvcodeV2(bdTaxitemsEntity);
        if (bdTaxitemsEntityList.size() == 0) {
            Assert.state(false, "根据存货编码{}没有查询到U8C税目档案", invcode);
        } else if (bdTaxitemsEntityList.size() >= 2) {
            Assert.state(false, "根据存货编码{}没有查询到U8C税目档案", invcode);
        }
        return bdTaxitemsEntityList.get(0);
    }

    /**
     * 2024年8月8日 10:54:48
     * 推送U8C销售订单方法
     *
     * @author liuyang
     */
    public SoSaleResultRootDto sendU8CTOCOrder(String param) {
        long startLong = System.currentTimeMillis();
        logger.info("TOB推送开始，推送参数：" + param + ",U8C_URL:" + OverallConstant.getOverAllValue("u8c_url"));
        String apiCode = "8000370006";
        String result = HttpRequest.post(OverallConstant.getOverAllValue("u8c_url")).header("appId", OverallConstant.getOverAllValue("appId"))//头信息，多个头信息多次调用此方法即可
                .header("usercode", OverallConstant.getOverAllValue("u8cApiUsercodePK")).header("password", OverallConstant.getOverAllValue("u8cApiPasswordPK")).header("system", OverallConstant.getOverAllValue("u8cApiSystemPK")).header("trantype", OverallConstant.getOverAllValue("u8cApiTrantypePK")).header("apiCode", apiCode)//头信息，多个头信息多次调用此方法即可
                .header("publicKey", OverallConstant.getOverAllValue("publicKey"))//头信息，多个头信息多次调用此方法即可
                .header("secretKey", OverallConstant.getOverAllValue("secretKey"))//头信息，多个头信息多次调用此方法即可
                .body(param)//表单内容
                .timeout(600000)//超时，毫秒
                .execute().body();
        logger.info("TOB推送结束，返回参数：" + result);
        long endLong = System.currentTimeMillis();
        logger.info("TOB接口请求耗时：" + (endLong - startLong));

        JSONObject jsonObject = JSON.parseObject(result);
        result = String.valueOf(jsonObject.get("attribute"));

        boolean isSuccess = false;
        SoSaleResultRootDto soSaleResultRootDto = null;
        if (result != null && !"".equals(result)) {
            ReusltStrDto reusltStrDto = JSON.parseObject(result, ReusltStrDto.class);
            if ("success".equals(reusltStrDto.getStatus())) {
                soSaleResultRootDto = resultDataHandle(reusltStrDto.getData());
                isSuccess = true;
            }
        }
        if (!isSuccess) {
            Assert.state(false, "TOB业务O出库单推送U8C销售订单失败 接口返回结果：{}", result);
        }
        return soSaleResultRootDto;
    }

    /**
     * 返回结果解析处理，在确认了success后调用
     *
     * @author liuyang
     */
    private SoSaleResultRootDto resultDataHandle(String resultData) {
        try {
            if (resultData != null && !"".equals(resultData)) {
                if (resultData.contains("[")) {
                    resultData = resultData.substring(1, resultData.length() - 1);
                }
                return JSON.parseObject(resultData, SoSaleResultRootDto.class);
            }
        } catch (Exception e) {
//            e.printStackTrace();
            logger.error("解析返回参数失败的错误", e);
            //如果解析失败，记录原因，但是不能影响结果的记录
        }
        return null;
    }

    /**
     * 返回结果解析处理，在确认了success后调用
     *
     * @author liuyang
     */
    private SaleinvoiceDto resultDataHandleV2(String resultData) {
        try {
            if (resultData != null && !"".equals(resultData)) {
                if (resultData.contains("[")) {
                    resultData = resultData.substring(1, resultData.length() - 1);
                }
                return JSON.parseObject(resultData, SaleinvoiceDto.class);
            }
        } catch (Exception e) {
//            e.printStackTrace();
            logger.error("解析返回参数失败的错误", e);
            //如果解析失败，记录原因，但是不能影响结果的记录
        }
        return null;
    }

    /**
     * 填充主表主键、业务日期、业务类型
     * 2024年8月15日 17:31:54
     *
     * @param ofsPassiveorderDetailEntity 无源件明细表 dao 对象
     * @param header                      O 无源件明细原始对象
     */
    private void createPrimaryKeyAndBusinessDateAndBusinessType(OfsPassiveorderDetailEntity ofsPassiveorderDetailEntity, PassiveStorageResponse.Header header) {
        if (ofsPassiveorderDetailEntity != null && header != null) {
            //主表主键
            if (header.getId() != null) {
                ofsPassiveorderDetailEntity.setHeaderid(header.getId());
            }
            //业务日期-关联时间
            if (header.getRelatedAt() != null) {
                ofsPassiveorderDetailEntity.setBusinessdate(header.getRelatedAt());
            }
            //业务类型
            ofsPassiveorderDetailEntity.setBusinesstype("TOB_ORDER");
        }
    }

    /**
     * 交易成功，代码同步逻辑
     *
     * @param passiveStorageResponseDataList O无源入库单对象
     * @author liuyang
     */
    private void implementSuccessfulTrade(List<PassiveStorageResponse.Data> passiveStorageResponseDataList) throws Exception {
        if (passiveStorageResponseDataList != null) {
            logger.info("TOB无源入库退货到账完成：{}行需要进行数据转换", passiveStorageResponseDataList.size());
        }
        if (passiveStorageResponseDataList != null && passiveStorageResponseDataList.size() > 0) {
            try {
                //转换基本档案
                String sceneType = "tran";
                List<OrderToBHeaderDtoV2> orderToBHeaderDtoV2s = queryBasicArchivesTran(passiveStorageResponseDataList, sceneType);

                //查询U8C业务流程
                BdBusitypeEntity bdBusitypeEntity = u8cOperationFlow();
                //查询销售收发类别
//                BdRdclEntity bdRdclEntity = rdclUtil.queryRdClObject("201");

                logger.info("TOB销售业务退货到账成功同步，档案转换成功对应的数量：{}行需要进行数据转换", orderToBHeaderDtoV2s.size());
                logger.info("TOB销售发票业务流程编码：{}", bdBusitypeEntity.getBusicode());
                for (int i = 0; i < orderToBHeaderDtoV2s.size(); i++) {
                    OrderToBHeaderDtoV2 orderToBHeaderDtoV2 = orderToBHeaderDtoV2s.get(i);
                    PassiveStorageResponse.Header header = orderToBHeaderDtoV2.getHeader();
                    List<PassiveStorageResponse.Details> details = orderToBHeaderDtoV2.getDetails();

                    try {
                        //销售公司、发货公司
                        BdCorpEntity bdCorpEntity = orderToBHeaderDtoV2.getBdCorpEntity();
                        //发货库存组织
                        BdCalbodyEntity bdCalbodyEntity = orderToBHeaderDtoV2.getBdCalbodyEntity();
                        //入库仓库
                        BdStordocEntity bdStordocEntity = orderToBHeaderDtoV2.getBdStordocEntity();
                        //销售组织
                        BdSalestruEntity bdSalestruEntity = orderToBHeaderDtoV2.getBdSalestruEntity();
                        //业务部门
                        BdDeptdocEntity bdDeptdocEntity = orderToBHeaderDtoV2.getBdDeptdocEntity();
                        //客商基本档案
                        BdCubasdocEntity bdCubasdocEntity = orderToBHeaderDtoV2.getBdCubasdocEntity();
                        //客商管理档案
                        BdCumandocEntity bdCumandocEntity = orderToBHeaderDtoV2.getBdCumandocEntity();
                        //发货公司
                        BdCorpEntity deliverGoodsCorp = orderToBHeaderDtoV2.getDeliverGoodsCorp();
                        //平台档案
                        BdDefdocEntity platformArchives = orderToBHeaderDtoV2.getPlatformArchives();
                        //生成业务日期
                        String successfulTradeDate = createSuccessFulTradeDate(header);
                        //店铺
                        BdDefdocEntity shopArchives = orderToBHeaderDtoV2.getShopArchives();
                        //U8C销售订单
                        SoSaleEntity soSaleEntity = orderToBHeaderDtoV2.getSoSaleEntity();
                        //U8C销售订单明细行
                        List<SoSaleorderBEntity> soSaleorderBEntityList = orderToBHeaderDtoV2.getSoSaleorderBEntityList();
                        //U8C销售出库单
                        IcGeneralHEntity icGeneralHEntity = orderToBHeaderDtoV2.getIcGeneralHEntity();
                        //U8C销售出库单明细行
                        List<IcGeneralBEntity> icGeneralBEntityList = orderToBHeaderDtoV2.getIcGeneralBEntityList();
                        //U8C销售订单执行情况明细表
                        List<ExtIntegrationTaskLivingDetailsQueryVo> extIntegrationTaskLivingDetailsQueryVos = orderToBHeaderDtoV2.getExtIntegrationTaskLivingDetailsQueryVos();
                        //OFS销售订单
                        SaleOrderMessageDto saleOrderMessageDto = orderToBHeaderDtoV2.getSaleOrderMessageDto();
                        //OFS售后订单
                        RerturnGoodsOrderSearchData ofsRertunOrder = orderToBHeaderDtoV2.getOfsRertunOrder();
                        //OFS收发类别
                        BdRdclEntity bdRdclEntity = orderToBHeaderDtoV2.getBdRdclEntity();

                        //红字销售发票表头
                        SalesInvoiceHeadDto salesInvoiceHeadDto = new SalesInvoiceHeadDto();
                        salesInvoiceHeadDto.setCbiztype(bdBusitypeEntity.getPkBusitype());
                        salesInvoiceHeadDto.setCcalbodyid(bdCalbodyEntity.getPkCalbody());
                        salesInvoiceHeadDto.setCoperatorid(OverallConstant.getOverAllValue("u8cApiZdrPK"));//制单人
                        salesInvoiceHeadDto.setCreceiptcorpid(bdCumandocEntity.getPkCumandoc());
                        salesInvoiceHeadDto.setCsalecorpid(bdSalestruEntity.getCsalestruid());
                        salesInvoiceHeadDto.setPk_corp(bdCorpEntity.getPkCorp());
                        salesInvoiceHeadDto.setDbilldate(successfulTradeDate);
                        salesInvoiceHeadDto.setFinvoicetype("1");//不传默认为1
                        salesInvoiceHeadDto.setCdeptid(bdDeptdocEntity.getPkDeptdoc());//部门
                        salesInvoiceHeadDto.setCwarehouseid(bdStordocEntity.getPkStordoc());//仓库
                        salesInvoiceHeadDto.setCdispatcherid(bdRdclEntity.getPkRdcl());//收发类别
                        salesInvoiceHeadDto.setCreceiptcustomerid(bdCumandocEntity.getPkCumandoc());//收货单位
                        salesInvoiceHeadDto.setCreceipttype("32");//单据类型
                        salesInvoiceHeadDto.setDmakedate(successfulTradeDate);//制单日期
                        salesInvoiceHeadDto.setNdiscountrate("100");//整单折扣
                        salesInvoiceHeadDto.setDapprovedate(successfulTradeDate);//审批日期
                        salesInvoiceHeadDto.setVnote(VNOTETYPE);
                        salesInvoiceHeadDto.setVdef17(ProfilesActiveConstant.sourceSystem1);
                        salesInvoiceHeadDto.setVdef19(header.getReceiptCode());
                        salesInvoiceHeadDto.setVdef20(header.getId());
                        //平台
                        salesInvoiceHeadDto.setPk_defdoc2(platformArchives.getPkDefdoc());
                        salesInvoiceHeadDto.setVdef2(platformArchives.getDocname());
                        //店铺
                        salesInvoiceHeadDto.setPk_defdoc1(shopArchives.getPkDefdoc());
                        salesInvoiceHeadDto.setVdef1(shopArchives.getDocname());
                        //单据红字标识
                        salesInvoiceHeadDto.setPk_defdoc16(OverallConstant.getOverAllValue("u8c自定义项档案-单据红字标识-Y主键"));
                        salesInvoiceHeadDto.setVdef16(OverallConstant.getOverAllValue("u8c自定义项档案-单据红字标识-Y名称"));
                        //收发类别
                        salesInvoiceHeadDto.setPk_defdoc3(bdRdclEntity.getPkRdcl());
                        salesInvoiceHeadDto.setVdef3(bdRdclEntity.getRdname());

                        //验证是否为指定的店铺，如果为true，则取结存价
                        Boolean isCheckShopChoose = balanceUnitPriceUtil.checkOfsShop(header.getStoreCode());

                        List<SalesInvoiceBodyDto> salesInvoiceBodyDtoList = new ArrayList<>();
                        for (int j = 0; j < details.size(); j++) {
                            PassiveStorageResponse.Details details1 = details.get(j);

                            //存货管理档案：取发货公司的存货管理档案
                            BdInvmandocEntity bdInvmandocEntity = queryInventoryMan(details1, bdCalbodyEntity.getPkCorp());
                            //存货基础档案
                            BdInvbasdocEntity bdInvbasdocEntity = queryStockBasicArchives(bdInvmandocEntity.getPkInvmandoc(), deliverGoodsCorp.getPkCorp());
                            //根据存货基础档案编码，查询当前存货的税率
                            BdTaxitemsEntity bdTaxitemsEntity1 = queryBdTaxitems(bdInvbasdocEntity.getInvcode());
                            //2024年8月30日 11:20:08 查找对应的售后订单的明细行，主要取价格
                            RerturnGoodsOrderSearchDetails afterSalesOrder = findAfterSalesOrder(details1, ofsRertunOrder);
                            //查找来源单据，销售发票的来源单据为销售出库单
                            IcGeneralBEntity sourceDocuments = findSourceDocuments(header, details1, soSaleorderBEntityList, icGeneralBEntityList, extIntegrationTaskLivingDetailsQueryVos);
                            //查找来源销售订单明细行
                            SoSaleorderBEntity sourceDocumentsV2 = findSourceDocumentsV2(header, details1, soSaleorderBEntityList, extIntegrationTaskLivingDetailsQueryVos);
                            //查询收支项目
//                            BdInvclEntity bdInvclEntity = queryU8CEntityUtil.queryBdInvbasdocByBdInvcl(bdInvbasdocEntity);
//                            BdCostsubjEntity bdCostsubjEntity = queryU8CEntityUtil.queryBdCostsubj(bdInvclEntity);

                            //计算公式
                            StringBuffer calculationFormula = new StringBuffer();
//                            calculationFormula.append("O实退金额");
                            //含税单价
//                            BigDecimal noriginalcurtaxprice = null;
                            String totalPayAmount = null;
                            try {
                                //综合判断对应的目标金额
                                totalPayAmount = getFloorPrice(isCheckShopChoose, bdInvmandocEntity, header, afterSalesOrder, calculationFormula, details1, bdInvbasdocEntity);
//                                noriginalcurtaxprice = new BigDecimal(totalPayAmount).divide(new BigDecimal(stockinB.getReceivedQty()), 20, BigDecimal.ROUND_HALF_UP).setScale(4, BigDecimal.ROUND_HALF_UP);
                            } catch (Exception e) {
                                logger.error("含税单价金额计算失败！", e);
                                Assert.state(false, "含税单价金额计算失败 原因：{}", e.getMessage());
                            }

                            Boolean isblargessflag = false;
                            if ("0".equals(new BigDecimal(totalPayAmount).stripTrailingZeros().toPlainString())) {
                                isblargessflag = true;
                            }

                            SalesInvoiceBodyDto salesInvoiceBodyDto = new SalesInvoiceBodyDto();
                            salesInvoiceBodyDto.setCinventoryid(bdInvmandocEntity.getPkInvmandoc());
                            salesInvoiceBodyDto.setCupreceipttype("4C");
                            salesInvoiceBodyDto.setCupsourcebillcode(soSaleEntity.getVreceiptcode());
                            salesInvoiceBodyDto.setNnumber("-" + details1.getQuantity());//数量
//                            salesInvoiceBodyDto.setNoriginalcurtaxprice(noriginalcurtaxprice.stripTrailingZeros().toPlainString());//含税单价
                            salesInvoiceBodyDto.setNoriginalcursummny("-" + new BigDecimal(totalPayAmount).setScale(2, BigDecimal.ROUND_HALF_UP).stripTrailingZeros().toPlainString());//价税合计 新逻辑
//                            salesInvoiceBodyDto.setNtaxrate(new BigDecimal(bdTaxitemsEntity1.getTaxratio()).stripTrailingZeros().toPlainString());//税率
                            //税率:取对应销售订单税率
                            salesInvoiceBodyDto.setNtaxrate(sourceDocumentsV2.getNtaxrate());
                            salesInvoiceBodyDto.setBlargessflag(isblargessflag);//是否赠品
                            salesInvoiceBodyDto.setCoriginalbillcode(soSaleEntity.getVreceiptcode());//源头单据号
                            salesInvoiceBodyDto.setCsourcebillbodyid(sourceDocumentsV2.getCorderBid());//源头单据明细行主键 (数据字典上是来源单据明细行主键，实际上是源头)
                            salesInvoiceBodyDto.setCsourcebillid(soSaleEntity.getCsaleid());//源头单据主表主键（数据字典上是来源单据主表主键，实际上是源头）
                            salesInvoiceBodyDto.setCupsourcebillbodyid(sourceDocuments.getCgeneralbid());//上层来源明细行主键
                            salesInvoiceBodyDto.setCupsourcebillcode(icGeneralHEntity.getVbillcode());//直接来源单据号
                            salesInvoiceBodyDto.setCupsourcebillid(icGeneralHEntity.getCgeneralhid());//来源主表主键
//                            salesInvoiceBodyDto.setVdef2(bdCostsubjEntity.getCostname());//收支项目
//                            salesInvoiceBodyDto.setPk_defdoc2(bdCostsubjEntity.getPkCostsubj());
                            salesInvoiceBodyDtoList.add(salesInvoiceBodyDto);

                            details1.setDef1(afterSalesOrder.getTotalAmount());//计算应收
                            details1.setDef2(calculationFormula.toString());//计算公式
                            details1.setRefundedAt(ofsRertunOrder.getHeader().getRefundedAt());//表头对应的退款完成时间
                        }
                        SalesInvoiceDto salesInvoiceDto = new SalesInvoiceDto();
                        salesInvoiceDto.setParentvo(salesInvoiceHeadDto);
                        salesInvoiceDto.setChildrenvo(salesInvoiceBodyDtoList);

                        List<SalesInvoiceDto> salesInvoiceDtoList = new ArrayList<>();
                        salesInvoiceDtoList.add(salesInvoiceDto);

                        Map<String, List<SalesInvoiceDto>> stringListMap = new HashMap<>();
                        stringListMap.put("billvos", salesInvoiceDtoList);

                        //推送到U8C生成销售发票
                        synchronized (PUSH_LOCK2) {
                            Boolean aBoolean = checkTobSalesInvoice(header.getId(), header.getReceiptCode());
                            if (!aBoolean) {
                                logger.error("经过SQL查询判断，在U8C红字销售发票中不存在OFS入库单号为：{} OFS入库主键为：{}的单据，将调用U8C接口执行推送！", header.getReceiptCode(), header.getId());
                                SaleinvoiceDto saleinvoiceDto = sendU8CTOCSoSaleinvoiceB(JSON.toJSONString(stringListMap));
                                String vreceiptcode = null;
                                String csaleid = null;
                                String pk_corp = null;
                                if (saleinvoiceDto != null && saleinvoiceDto.getParentvo() != null && saleinvoiceDto.getChildrenvo() != null) {
                                    SaleinvoiceHeadDto parentvo = saleinvoiceDto.getParentvo();
                                    List<SaleinvoiceBodyDto> childrenvo = saleinvoiceDto.getChildrenvo();
                                    vreceiptcode = parentvo.getVreceiptcode();
                                    csaleid = parentvo.getCsaleid();
                                    pk_corp = parentvo.getPk_corp();
                                }
                                logger.info("TOB销售发票(红字)生成成功 编码：{} 主键：{} 发票公司：{}", vreceiptcode, csaleid, pk_corp);
                                //记录成功
                                updateSuccessOrFail2(details, "Y", "success", vreceiptcode, csaleid);
                            } else {
                                logger.error("经过SQL查询判断，在U8C红字销售发票中已经存在OFS无源入库单号为：{} OFS无源入库主键为：{}的单据，为了避免造成单据重复，不推送到U8C！", header.getReceiptCode(), header.getId());
                            }
                        }
                    } catch (Exception e) {
                        logger.error("TOB售后到账完成推送U8C抛出异常", e);
                        // 记录失败
                        String message = e.getMessage();
                        if (message == null) {
                            message = "未知错误";
                        }
                        updateSuccessOrFail2(details, "N", message, null, null);
                    }
                }
            } catch (Exception e) {
                logger.error("TOB外层转换逻辑抛出异常", e);
            }
        }
    }

    /**
     * 2024年8月28日 17:17:33
     * 生成业务日期，以交易成功时间作为业务日期
     *
     * @author liuyang
     */
    private String createSuccessFulTradeDate(PassiveStorageResponse.Header header) {
        String code = null;
        if (header != null && header.getReceiptCode() != null) {
            code = header.getReceiptCode();
        }
        if (header != null && header.getRelatedAt() != null) {
            String relatedAt = header.getRelatedAt();
            String businessFormat = null;
            try {
                Date dbill = DateUtil.parse(relatedAt);
                businessFormat = DateUtil.format(dbill, "yyyy-MM-dd");
            } catch (Exception e) {
                logger.error("业务日期生成失败relatedAt(O 关联时间)解析异常：{} O 无源入库单号：{}", e.getMessage(), code);
                Assert.state(false, "业务日期生成失败closedAt(O 关联时间)解析异常：{} O 无源入库单号：{}", e.getMessage(), code);
            }
            return businessFormat;
        } else {
            logger.error("业务日期生成失败relatedAt(O 关联时间)不能为空 O 无源入库单号:{}", code);
            Assert.state(false, "业务日期生成失败relatedAt(O 关联时间)不能为空 O 无源入库单号:{}", code);
            return null;
        }
    }

    /**
     * 2024年8月30日 11:29:24
     * 推送U8C销售发票
     *
     * @author liuyang
     */
    public SaleinvoiceDto sendU8CTOCSoSaleinvoiceB(String param) throws Exception {
        long startLong = System.currentTimeMillis();
        logger.info("TOB销售发票推送开始，推送参数：" + param + ",U8C_URL:" + OverallConstant.getOverAllValue("u8c_url"));
        String apiCode = "8000370057";
        String result = HttpRequest.post(OverallConstant.getOverAllValue("u8c_url")).header("appId", OverallConstant.getOverAllValue("appId"))//头信息，多个头信息多次调用此方法即可
                .header("usercode", OverallConstant.getOverAllValue("u8cApiUsercodePK")).header("password", OverallConstant.getOverAllValue("u8cApiPasswordPK")).header("system", OverallConstant.getOverAllValue("u8cApiSystemPK")).header("trantype", OverallConstant.getOverAllValue("u8cApiTrantypePK")).header("apiCode", apiCode)//头信息，多个头信息多次调用此方法即可
                .header("publicKey", OverallConstant.getOverAllValue("publicKey"))//头信息，多个头信息多次调用此方法即可
                .header("secretKey", OverallConstant.getOverAllValue("secretKey"))//头信息，多个头信息多次调用此方法即可
                .body(param)//表单内容
                .timeout(600000)//超时，毫秒
                .execute().body();
        //2024年8月29日 17:56:50 如果http请求超时，则会抛给上层方法，上层方法会完成异常的捕捉
        logger.info("TOB销售发票推送结束，返回参数：" + result);
        long endLong = System.currentTimeMillis();
        logger.info("TOB销售发票接口请求耗时：" + (endLong - startLong));

        JSONObject jsonObject = JSON.parseObject(result);
        result = String.valueOf(jsonObject.get("attribute"));

        boolean isSuccess = false;
        SaleinvoiceDto soSaleResultRootDto = null;
        if (result != null && !"".equals(result)) {
            ReusltStrDto reusltStrDto = JSON.parseObject(result, ReusltStrDto.class);
            if ("success".equals(reusltStrDto.getStatus())) {
                soSaleResultRootDto = resultDataHandleV2(reusltStrDto.getData());
                isSuccess = true;
            }
        }
        if (!isSuccess) {
            Assert.state(false, "TOB业务O出库单推送U8C销售发票失败 接口返回结果：{}", result);
        }
        return soSaleResultRootDto;
    }

    /**
     * 通过售后入库单明细行，查找售后订单明细行
     *
     * @param stockinB       售后订单明细行
     * @param ofsRertunOrder OFS售后订单
     * @author liuyang
     */
    private RerturnGoodsOrderSearchDetails findAfterSalesOrder(PassiveStorageResponse.Details stockinB, RerturnGoodsOrderSearchData ofsRertunOrder) {
        Assert.notNull(stockinB, "stockinB不能为空！");
        Assert.notNull(ofsRertunOrder, "saleOrderMessageDto不能为空！");

        Assert.notNull(ofsRertunOrder.getHeader(), "售后订表头不能为空！");
        Assert.notNull(ofsRertunOrder.getDetails(), "售后订单表头");
        RerturnGoodsOrderSearchHeader header = ofsRertunOrder.getHeader();
        List<RerturnGoodsOrderSearchDetails> details1 = ofsRertunOrder.getDetails();
        if (details1 == null || details1.size() == 0) {
            Assert.state(false, "售后订单明细行不能为空，size不能为0！");
        }
        for (int i = 0; i < details1.size(); i++) {
            RerturnGoodsOrderSearchDetails rerturnGoodsOrderSearchDetails = details1.get(i);
            if (rerturnGoodsOrderSearchDetails.getSkuCode().equals(stockinB.getSkuCode())) {
                return rerturnGoodsOrderSearchDetails;
            }
        }
        Assert.state(false, "通过无源入库单明细行({})无法匹配到售后订单明细行", stockinB.getSkuCode());
        return null;
    }

    /**
     * 查找来源单据,销售发票的来源单据为销售出库单，生成TOB销售订单时，明细行传O的明细行主键，查找逻辑
     * O明细行主键 -> 定位到U8C销售订单明细行 -> 销售出库单明细行
     *
     * @param header                                  O表头明细行
     * @param stockinB                                O明细行
     * @param soSaleorderBEntityList                  U8C销售订单明细集合
     * @param icGeneralBEntityList                    U8C销售出库单明细集合
     * @param extIntegrationTaskLivingDetailsQueryVos U8C销售订单执行情况明细表
     * @author liuyang
     */
    private IcGeneralBEntity findSourceDocuments(PassiveStorageResponse.Header header, PassiveStorageResponse.Details stockinB, List<SoSaleorderBEntity> soSaleorderBEntityList, List<IcGeneralBEntity> icGeneralBEntityList, List<ExtIntegrationTaskLivingDetailsQueryVo> extIntegrationTaskLivingDetailsQueryVos) {
        Assert.notNull(header, "header不能为空");
        Assert.notNull(stockinB, "detailsDto不能为空");
        Assert.notNull(soSaleorderBEntityList, "soSaleorderBEntityList不能为空");
        Assert.notNull(icGeneralBEntityList, "icGeneralBEntityList不能为空");
        Assert.notNull(extIntegrationTaskLivingDetailsQueryVos, "extIntegrationTaskLivingDetailsQueryVos不能为空");

        ExtIntegrationTaskLivingDetailsQueryVo targetExtIntegrationTaskLivingDetailsQueryVo = null;
        for (int i = 0; i < extIntegrationTaskLivingDetailsQueryVos.size(); i++) {
            ExtIntegrationTaskLivingDetailsQueryVo extIntegrationTaskLivingDetailsQueryVo = extIntegrationTaskLivingDetailsQueryVos.get(i);
            if (extIntegrationTaskLivingDetailsQueryVo.getVdef20().equals(stockinB.getId())) {
                targetExtIntegrationTaskLivingDetailsQueryVo = extIntegrationTaskLivingDetailsQueryVo;
            }
        }
        Assert.notNull(targetExtIntegrationTaskLivingDetailsQueryVo, "无法匹配到销售订单执行情况明细行，O明细行主键", stockinB.getId());

        SoSaleorderBEntity targetSoSaleorderBEntity = null;
        for (int i = 0; i < soSaleorderBEntityList.size(); i++) {
            SoSaleorderBEntity soSaleorderBEntity = soSaleorderBEntityList.get(i);
            if (targetExtIntegrationTaskLivingDetailsQueryVo.getCsale_bid().equals(soSaleorderBEntity.getCorderBid())) {
                targetSoSaleorderBEntity = soSaleorderBEntity;
            }
        }
        Assert.notNull(targetSoSaleorderBEntity, "根据O出库单明细主键:{}，无法匹配到U8C销售订单明细行");

        for (int i = 0; i < icGeneralBEntityList.size(); i++) {
            IcGeneralBEntity icGeneralBEntity = icGeneralBEntityList.get(i);
            if (icGeneralBEntity.getCsourcebillbid().equals(targetSoSaleorderBEntity.getCorderBid())) {
                return icGeneralBEntity;
            }
        }
        Assert.state(false, "根据销售订单明细行主键：{} 无法匹配到销售出库单明细行", targetSoSaleorderBEntity.getCorderBid());
        return null;
    }

    /**
     * 查找销售订单明细行
     *
     * @param header                 O表头明细行
     * @param stockinB               O明细行
     * @param soSaleorderBEntityList U8C销售订单明细集合
     * @author liuyang
     */
    private SoSaleorderBEntity findSourceDocumentsV2(PassiveStorageResponse.Header header, PassiveStorageResponse.Details stockinB, List<SoSaleorderBEntity> soSaleorderBEntityList, List<ExtIntegrationTaskLivingDetailsQueryVo> extIntegrationTaskLivingDetailsQueryVos) {
        Assert.notNull(header, "header不能为空");
        Assert.notNull(stockinB, "stockinB不能为空");
        Assert.notNull(soSaleorderBEntityList, "soSaleorderBEntityList不能为空");
        Assert.notNull(extIntegrationTaskLivingDetailsQueryVos, "extIntegrationTaskLivingDetailsQueryVos不能为空!");

        ExtIntegrationTaskLivingDetailsQueryVo targetExtIntegrationTaskLivingDetailsQueryVo = null;
        for (int i = 0; i < extIntegrationTaskLivingDetailsQueryVos.size(); i++) {
            ExtIntegrationTaskLivingDetailsQueryVo extIntegrationTaskLivingDetailsQueryVo = extIntegrationTaskLivingDetailsQueryVos.get(i);
            if (extIntegrationTaskLivingDetailsQueryVo.getVdef20().equals(stockinB.getId())) {
                targetExtIntegrationTaskLivingDetailsQueryVo = extIntegrationTaskLivingDetailsQueryVo;
            }
        }
        Assert.notNull(targetExtIntegrationTaskLivingDetailsQueryVo, "无法匹配到销售订单执行情况明细行，O明细行主键", stockinB.getId());

        SoSaleorderBEntity targetSoSaleorderBEntity = null;
        for (int i = 0; i < soSaleorderBEntityList.size(); i++) {
            SoSaleorderBEntity soSaleorderBEntity = soSaleorderBEntityList.get(i);
            if (targetExtIntegrationTaskLivingDetailsQueryVo.getCsale_bid().equals(soSaleorderBEntity.getCorderBid())) {
                targetSoSaleorderBEntity = soSaleorderBEntity;
            }
        }
        Assert.notNull(targetSoSaleorderBEntity, "根据O出库单明细主键:{}，无法匹配到U8C销售订单明细行");
        return targetSoSaleorderBEntity;
    }

    private static final Object checkTobOrderLock = new Object();

    /**
     * 验证TOB销售订单，是否已经生成，如果已经生成，则返回true,否则返回false
     *
     * @param ofsId   ofs主键
     * @param ofsCode ofs编码
     * @author liuyang
     */
    private Boolean checkTobOrder(String ofsId, String ofsCode) throws Exception {
        Assert.notNull(ofsId, "ofsId不能为空");
        Assert.notNull(ofsCode, "ofsCode不能为空");
        synchronized (checkTobOrderLock) {
            SoSaleEntity soSaleEntity = new SoSaleEntity();
            soSaleEntity.setDr(0L);
            soSaleEntity.setDataSourceCode("lets_u8c");
            soSaleEntity.setVdef19(ofsCode);
            soSaleEntity.setVdef20(ofsId);
            soSaleEntity.setBretinvflag("Y");//仅查询退货的销售订单
            List<SoSaleEntity> soSaleEntityList = iSoSaleDao.query(soSaleEntity);
            if (soSaleEntityList.size() > 0) {
                SoSaleEntity soSaleEntity1 = soSaleEntityList.get(0);
                logger.error("O无源入库单主键：{} O无源入库单编码：{} 该单据在U8C已经存在U8C销售订单，并且销售订单编码为：{} 对应的公司为：{}", ofsId, ofsCode, soSaleEntity1.getVreceiptcode(), soSaleEntity1.getPkCorp());
                return true;
            }
            return false;
        }
    }

    private static final Object checkTobSalesInvoiceLock = new Object();

    /**
     * 验证TOB销售发票，是否已经生成，仅验证负数的发票是否存在！
     *
     * @param ofsId   ofs销售出库单主键
     * @param ofsCode ofs销售出库单编码
     * @author liuyang
     */
    private Boolean checkTobSalesInvoice(String ofsId, String ofsCode) throws Exception {
        Assert.notNull(ofsId, "ofsId不能为空");
        Assert.notNull(ofsCode, "ofsCode不能为空");
        synchronized (checkTobSalesInvoiceLock) {
            SoSaleinvoiceEntity soSaleinvoiceEntity = new SoSaleinvoiceEntity();
            soSaleinvoiceEntity.setDr("0");
            soSaleinvoiceEntity.setVdef19(ofsCode);
            soSaleinvoiceEntity.setVdef20(ofsId);
            soSaleinvoiceEntity.setDataSourceCode("lets_u8c");
            soSaleinvoiceEntity.setVnote(VNOTETYPE);
            List<SoSaleinvoiceEntity> soSaleinvoiceEntityList = iSoSaleinvoiceDao.query(soSaleinvoiceEntity);
            if (soSaleinvoiceEntityList != null && soSaleinvoiceEntityList.size() > 0) {
                SoSaleinvoiceEntity soSaleinvoiceEntity1 = soSaleinvoiceEntityList.get(0);
                logger.error("OFS销售出库单主键：{} OFS销售出库单编码：{} 该单据在U8C已经存在U8C销售发票，并且销售发票编码为：{} 对应的公司为：{}", ofsId, ofsCode, soSaleinvoiceEntity1.getVreceiptcode(), soSaleinvoiceEntity1.getPkCorp());
                return true;
            }
        }
        return false;
    }

    /**
     * 计算时间间隔
     *
     * @author liuyang
     */
    public String computingTime(String param) {
        if (param != null && !"".equals(param)) {
            String[] split = param.split("/");
            if (!(split.length == 2)) {
                Assert.state(false, "传递的日期格式不完整 格式参考：2024-04-01/2024-04-30");
            }

            LocalDate startDate = LocalDate.parse(split[0]);
            LocalDate endDate = LocalDate.parse(split[1]);

            List<String> stringArrayList = new ArrayList<>();
            List<String> dateRange = getDateRange(startDate, endDate);
            if (dateRange != null && dateRange.size() > 0) {
                for (int i = 0; i < dateRange.size(); i++) {
                    String dateStr = dateRange.get(i);
                    StringBuffer stringBuffer = new StringBuffer();
                    stringBuffer.append(dateStr);
                    stringBuffer.append(" 00:00:00");
                    stringBuffer.append(",");
                    stringBuffer.append(dateStr);
                    stringBuffer.append(" 23:59:59");
                    stringArrayList.add(stringBuffer.toString());
                }
            }
            String collectDateStr = stringArrayList.stream().collect(Collectors.joining("*"));
            logger.info("类型：time_frame 生成的日期范围：" + collectDateStr);
            return collectDateStr;
        }
        return null;
    }

    /**
     * 计算日期范围
     *
     * @author liuyang
     */
    private List<String> getDateRange(LocalDate startDate, LocalDate endDate) {
        List<String> dateRange = new ArrayList<>();
        LocalDate currentDate = startDate;
        while (!currentDate.isAfter(endDate)) {
            dateRange.add(currentDate.format(DateTimeFormatter.ISO_DATE));
            currentDate = currentDate.plusDays(1);
        }
        return dateRange;
    }

    /**
     * 分割日期之后，再进行推送
     *
     * @param param     日期参数
     * @param sceneType 场景类型 TOB库存、TOB确认收入
     * @author liuyang
     */
    public void splitDateAndPush(String param, String sceneType) throws Exception {
        try {
            Assert.notNull(param, "param不能为空!");
            Assert.state(!"".equals(param), "param不能为空！");

            Assert.notNull(sceneType, "sceneType不能为空！");
            Assert.state(!"".equals(sceneType), "sceneType不能为空！");

            if (param.contains("*")) {
                String[] params = param.split("\\*");
                if (params.length > 0) {
                    for (int i = 0; i < params.length; i++) {
                        String indexStr = params[i];
                        String[] split = indexStr.split(",");
                        logger.info("splitDateAndPush方法正在执行主要的逻辑 开始时间：{} 结束时间：{}", split[0], split[1]);
                        if (sceneType.equals(STOCK)) {
                            startImplementByStockTime(split[0], split[1]);
                        } else if (sceneType.equals(TRAN)) {
                            startImplementByTradeTime(split[0], split[1]);
                        }
                    }
                }
            } else {
                String[] split = param.split(",");
                logger.info("splitDateAndPush方法正在执行主要的逻辑 开始时间：{} 结束时间：{}", split[0], split[1]);
                if (sceneType.equals(STOCK)) {
                    startImplementByStockTime(split[0], split[1]);
                } else if (sceneType.equals(TRAN)) {
                    startImplementByTradeTime(split[0], split[1]);
                }
            }
        } catch (Exception e) {
            logger.error("记录splitDateAndPush方法抛出的异常", e);
        }
    }

    /**
     * 处理TOB-库存同步的成功、失败错误逻辑
     *
     * @param sonDetailsDtoList O无源入库单明细行
     * @param newstate          推送状态
     * @param newTransmitInfo   错误详情
     * @param newsystemnumber   下游单号
     * @param newsystemprimary  下游主键
     * @author liuyang
     */
    private void updateSuccessOrFail1(List<PassiveStorageResponse.Details> sonDetailsDtoList, String newstate, String newTransmitInfo, String newsystemnumber, String newsystemprimary) {
        if (newTransmitInfo != null && !"".equals(newTransmitInfo.trim()) && newTransmitInfo.length() >= 400) {
            newTransmitInfo = newTransmitInfo.substring(0, 400);
        }

        String finalNewTransmitInfo = newTransmitInfo;
        Thread thread = new Thread(new Runnable() {
            @Override
            public void run() {
                try {
                    String successY = "Y";
                    if (sonDetailsDtoList != null && sonDetailsDtoList.size() > 0) {
                        List<OfsPassiveorderDetailEntity> ofsPassiveorderDetailEntityArrayList = new ArrayList<>();
                        for (int i = 0; i < sonDetailsDtoList.size(); i++) {
                            PassiveStorageResponse.Details details = sonDetailsDtoList.get(i);
                            OfsPassiveorderDetailEntity ofsPassiveorderDetailEntity = new OfsPassiveorderDetailEntity();
                            ofsPassiveorderDetailEntity.setId(details.getId());
                            ofsPassiveorderDetailEntity.setTransactionDate(details.getRefundedAt());
                            ofsPassiveorderDetailEntity.setNewpushdate(getNewDateStr());
                            ofsPassiveorderDetailEntity.setNewtransmitinfo(finalNewTransmitInfo);
                            ofsPassiveorderDetailEntity.setNewstate(newstate);
                            if (successY.equals(newstate)) {
                                ofsPassiveorderDetailEntity.setNewsystemnumber(newsystemnumber);
                                ofsPassiveorderDetailEntity.setNewsystemprimary(newsystemprimary);
                            }
                            ofsPassiveorderDetailEntity.setDef1(details.getDef1());
                            ofsPassiveorderDetailEntity.setDef2(details.getDef2());
                            ofsPassiveorderDetailEntityArrayList.add(ofsPassiveorderDetailEntity);
                        }

                        //以50行为一个批次，推送到Mysql
                        if (ofsPassiveorderDetailEntityArrayList.size() > 0) {
                            List<List<OfsPassiveorderDetailEntity>> lists = SplitListByCountUtil.splitListByCount(ofsPassiveorderDetailEntityArrayList, 50);
                            for (int i = 0; i < lists.size(); i++) {
                                List<OfsPassiveorderDetailEntity> ofsPassiveorderDetailEntities = lists.get(i);
                                iOfsPassiveorderDetailDao.entityInsertOrUpdateBatchByStock(ofsPassiveorderDetailEntities);
                            }
                        }
                    }
                } catch (Exception e) {
                    logger.error("无源件日志同步，抛出异常", e);
                }
            }
        });
        thread.start();
        try {
            thread.join();
        } catch (Exception e) {
            logger.error("updateSuccessOrFail1方法现场抛出异常", e);
        }
    }

    /**
     * 生成当前日期
     *
     * @author liuyang
     */
    private String getNewDateStr() {
        LocalDateTime now = LocalDateTime.now();
        DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss");
        return now.format(formatter);
    }

    /**
     * 处理TOC-库存同步的成功、失败错误逻辑
     *
     * @author liuyang
     */
    private void updateSuccessOrFail2(List<PassiveStorageResponse.Details> value, String newstate, String newTransmitInfo, String newsystemnumber, String newsystemprimary) {
        if (newTransmitInfo != null && !"".equals(newTransmitInfo.trim()) && newTransmitInfo.length() >= 400) {
            newTransmitInfo = newTransmitInfo.substring(0, 400);
        }

        String finalNewTransmitInfo = newTransmitInfo;
        Thread thread = new Thread(new Runnable() {
            @Override
            public void run() {
                try {
                    String successY = "Y";
                    if (value != null && value.size() > 0) {
                        List<OfsPassiveorderDetailEntity> ofsPassiveorderDetailEntityArrayList = new ArrayList<>();
                        for (int i = 0; i < value.size(); i++) {
                            PassiveStorageResponse.Details details = value.get(i);

                            OfsPassiveorderDetailEntity ofsPassiveorderDetailEntity = new OfsPassiveorderDetailEntity();
                            ofsPassiveorderDetailEntity.setId(details.getId());
                            ofsPassiveorderDetailEntity.setTransactionDate(details.getRefundedAt());
                            ofsPassiveorderDetailEntity.setNewpushdate2(getNewDateStr());
                            ofsPassiveorderDetailEntity.setNewtransmitinfo2(finalNewTransmitInfo);
                            ofsPassiveorderDetailEntity.setNewstate2(newstate);
                            if (successY.equals(newstate)) {
                                ofsPassiveorderDetailEntity.setNewsystemnumber2(newsystemnumber);
                                ofsPassiveorderDetailEntity.setNewsystemprimary2(newsystemprimary);
                            }
                            ofsPassiveorderDetailEntity.setDef1(details.getDef1());
                            ofsPassiveorderDetailEntity.setDef2(details.getDef2());
                            ofsPassiveorderDetailEntityArrayList.add(ofsPassiveorderDetailEntity);
                        }

                        //以50行为一个批次，推送到Mysql
                        if (ofsPassiveorderDetailEntityArrayList.size() > 0) {
                            List<List<OfsPassiveorderDetailEntity>> lists = SplitListByCountUtil.splitListByCount(ofsPassiveorderDetailEntityArrayList, 50);
                            for (int i = 0; i < lists.size(); i++) {
                                List<OfsPassiveorderDetailEntity> ofsPassiveorderDetailEntities = lists.get(i);
                                iOfsPassiveorderDetailDao.entityInsertOrUpdateBatchByTran(ofsPassiveorderDetailEntities);
                            }
                        }
                    }
                } catch (Exception e) {
                    logger.error("TOB确认收入同步日志，抛出异常", e);
                }
            }
        });
        thread.start();
        try {
            thread.join();
        } catch (Exception e) {
            logger.error("updateSuccessOrFail1方法现场抛出异常", e);
        }
    }

    /**
     * 批量修改成功、或者失败，适合档案查询的部分
     *
     * @param errorHeaderDetailsDtoDtoV3List 错误数据行
     * @param sceneType                      场景类型
     * @author liuyang
     */
    private void updateFailOrSuccessTocofsSaleoutDetailedArchiveInquiryStock(List<ErrorHeaderDetailsDtoDtoV3> errorHeaderDetailsDtoDtoV3List, String sceneType) throws Exception {
        Assert.notNull(errorHeaderDetailsDtoDtoV3List, "errorHeaderDetailsDtoDtoV3List不能为空！");
        Assert.notNull(sceneType, "sceneType不能为空！");

        Thread thread = new Thread(new Runnable() {
            @Override
            public void run() {
                try {
                    if (errorHeaderDetailsDtoDtoV3List != null && errorHeaderDetailsDtoDtoV3List.size() > 0) {
                        List<OfsPassiveorderDetailEntity> tocofsSaleoutDetailedEntityList = new ArrayList<>();
                        for (int i = 0; i < errorHeaderDetailsDtoDtoV3List.size(); i++) {
                            ErrorHeaderDetailsDtoDtoV3 errorHeaderDetailsDtoDtoV3 = errorHeaderDetailsDtoDtoV3List.get(i);
                            PassiveStorageResponse.Header header = errorHeaderDetailsDtoDtoV3.getHeader();
                            List<PassiveStorageResponse.Details> details = errorHeaderDetailsDtoDtoV3.getDetails();

                            String newstate = errorHeaderDetailsDtoDtoV3.getNewstate();
                            String newPushDate = errorHeaderDetailsDtoDtoV3.getNewPushDate();
                            String newTransmitInfo = errorHeaderDetailsDtoDtoV3.getNewTransmitInfo();
                            String newsystemnumber = errorHeaderDetailsDtoDtoV3.getNewsystemnumber();
                            String newsystemprimary = errorHeaderDetailsDtoDtoV3.getNewsystemprimary();
//                            String transactionDate = errorHeaderDetailsDtoDtoV3.getTransactionDate();

                            //如果报错内容太长了，则仅保留400个长度，维护数据库性能，缓解资源公平使用
                            if (newTransmitInfo != null && !"".equals(newTransmitInfo.trim()) && newTransmitInfo.length() >= 400) {
                                newTransmitInfo = newTransmitInfo.substring(0, 400);
                            }

                            for (int j = 0; j < details.size(); j++) {
                                PassiveStorageResponse.Details details1 = details.get(j);

                                OfsPassiveorderDetailEntity ofsPassiveorderDetailEntity = new OfsPassiveorderDetailEntity();
                                ofsPassiveorderDetailEntity.setId(details1.getId());
                                ofsPassiveorderDetailEntity.setTransactionDate(details1.getRefundedAt());
                                if (sceneType.equals("stock")) {
                                    ofsPassiveorderDetailEntity.setNewpushdate(newPushDate);
                                    ofsPassiveorderDetailEntity.setNewtransmitinfo(newTransmitInfo);
                                    ofsPassiveorderDetailEntity.setNewstate(newstate);
                                    if (!"N".equals(newstate)) {
                                        ofsPassiveorderDetailEntity.setNewsystemnumber(newsystemnumber);
                                        ofsPassiveorderDetailEntity.setNewsystemprimary(newsystemprimary);
                                    }
                                } else if (sceneType.equals("tran")) {
                                    ofsPassiveorderDetailEntity.setNewpushdate2(newPushDate);
                                    ofsPassiveorderDetailEntity.setNewtransmitinfo2(newTransmitInfo);
                                    ofsPassiveorderDetailEntity.setNewstate2(newstate);
                                    if (!"N".equals(newstate)) {
                                        ofsPassiveorderDetailEntity.setNewsystemnumber2(newsystemnumber);
                                        ofsPassiveorderDetailEntity.setNewsystemprimary2(newTransmitInfo);
                                    }
                                }
                                tocofsSaleoutDetailedEntityList.add(ofsPassiveorderDetailEntity);
                            }
                        }

                        //以50行为一个批次更新状态,并且入库和确认收入调用不同的方法
                        if (tocofsSaleoutDetailedEntityList.size() > 0) {
                            List<List<OfsPassiveorderDetailEntity>> lists = SplitListByCountUtil.splitListByCount(tocofsSaleoutDetailedEntityList, 50);
                            for (int i = 0; i < lists.size(); i++) {
                                List<OfsPassiveorderDetailEntity> ofsPassiveorderDetailEntities = lists.get(i);
                                if (sceneType.equals("stock")) {
                                    iOfsPassiveorderDetailDao.entityInsertOrUpdateBatchByStock(ofsPassiveorderDetailEntities);
                                } else if (sceneType.equals("tran")) {
                                    iOfsPassiveorderDetailDao.entityInsertOrUpdateBatchByTran(ofsPassiveorderDetailEntities);
                                }
                            }
                        }
                    }
                } catch (Exception e) {
                    logger.error("无源件业务填充出库明细日志抛出异常", e);
                }
            }
        });
        thread.start();
        try {
            thread.join();
        } catch (Exception e) {
            logger.error("updateFailOrSuccessTocofsSaleoutDetailedArchiveInquiry方法调用join 跑出异常", e);
        }
    }


    /**
     * 批量修改成功、或者失败，适合档案查询的部分
     *
     * @author liuyang
     */
    private void updateFailOrSuccessTocofsSaleoutDetailedArchiveInquiryTran(List<ErrorHeaderDetailsDtoDtoV2> errorHeaderDetailsDtoDtoList) {
        Assert.notNull(errorHeaderDetailsDtoDtoList, "errorHeaderDetailsDtoDtoList不能为空！");

        Thread thread = new Thread(new Runnable() {
            @Override
            public void run() {
                try {
                    if (errorHeaderDetailsDtoDtoList != null && errorHeaderDetailsDtoDtoList.size() > 0) {
                        List<TocofsReturngoodsDetailedEntity> tocofsReturngoodsDetailedEntityList = new ArrayList<>();
                        for (int i = 0; i < errorHeaderDetailsDtoDtoList.size(); i++) {
                            ErrorHeaderDetailsDtoDtoV2 errorHeaderDetailsDtoDtoV2 = errorHeaderDetailsDtoDtoList.get(i);
                            StockinOrderSearchResponse.StockinOrder.StockinH header = errorHeaderDetailsDtoDtoV2.getHeader();
                            List<StockinOrderSearchResponse.StockinOrder.StockinB> details = errorHeaderDetailsDtoDtoV2.getDetails();

                            String newstate = errorHeaderDetailsDtoDtoV2.getNewstate2();
                            String newPushDate = errorHeaderDetailsDtoDtoV2.getNewPushDate2();
                            String newTransmitInfo = errorHeaderDetailsDtoDtoV2.getNewTransmitInfo2();

                            //如果报错内容太长了，则仅保留500个长度
                            if (newTransmitInfo != null && !"".equals(newTransmitInfo.trim()) && newTransmitInfo.length() >= 400) {
                                newTransmitInfo = newTransmitInfo.substring(0, 400);
                            }

                            for (int j = 0; j < details.size(); j++) {
                                StockinOrderSearchResponse.StockinOrder.StockinB stockinB = details.get(j);

                                TocofsReturngoodsDetailedEntity tocofsSaleoutDetailedEntity = new TocofsReturngoodsDetailedEntity();
                                tocofsSaleoutDetailedEntity.setId(stockinB.getId());
                                tocofsSaleoutDetailedEntity.setNewpushdate2(newPushDate);
                                tocofsSaleoutDetailedEntity.setNewtransmitinfo2(newTransmitInfo);
                                tocofsSaleoutDetailedEntity.setNewstate2(newstate);
                                tocofsSaleoutDetailedEntity.setNewsystemnumber2(null);
                                tocofsSaleoutDetailedEntity.setNewsystemprimary2(null);
                                tocofsReturngoodsDetailedEntityList.add(tocofsSaleoutDetailedEntity);
                            }
                        }

                        //以50行为一个批次更新状态
                        if (tocofsReturngoodsDetailedEntityList.size() > 0) {
                            List<List<TocofsReturngoodsDetailedEntity>> splitListByCount = SplitListByCountUtil.splitListByCount(tocofsReturngoodsDetailedEntityList, 50);
                            for (int i = 0; i < splitListByCount.size(); i++) {
                                List<TocofsReturngoodsDetailedEntity> tocofsReturngoodsDetailedEntityList1 = splitListByCount.get(i);
                                iTocofsReturngoodsDetailedDao.entityInsertOrUpdateBatchByTobRerturnTranV2(tocofsReturngoodsDetailedEntityList1);
                            }
                        }
                    }
                } catch (Exception e) {
                    logger.error("TOB填充出库明细日志抛出异常", e);
                }
            }
        });
        thread.start();
        try {
            thread.join();
        } catch (Exception e) {
            logger.error("updateFailOrSuccessTocofsSaleoutDetailedArchiveInquiry方法现场抛出异常", e);
        }
    }

    /**
     * 获取结存金额或者采购金额
     * Boolean isCheckShopChoose
     *
     * @param isCheckShopChoose  true取OFS实付金额、false取结存金额或者采购价
     * @param bdInvmandocEntity  存货管理档案
     * @param header             O无源头入库单表头
     * @param afterSalesOrder    对应的OFS售后订单明细行
     * @param calculationFormula 计算公式
     * @param details1           O无源入库单明细行
     * @param bdInvbasdocEntity  存货基本档案
     * @author liuyang
     */
    private String getFloorPrice(Boolean isCheckShopChoose, BdInvmandocEntity bdInvmandocEntity, PassiveStorageResponse.Header header, RerturnGoodsOrderSearchDetails afterSalesOrder, StringBuffer calculationFormula, PassiveStorageResponse.Details details1, BdInvbasdocEntity bdInvbasdocEntity) throws Exception {
        Assert.notNull(isCheckShopChoose, "isCheckShopChoose不能为空");
        Assert.notNull(bdInvmandocEntity, "bdInvmandocEntity不能为空");
        Assert.notNull(header, "header不能为空");
        Assert.notNull(afterSalesOrder, "afterSalesOrder不能为空");
        Assert.notNull(calculationFormula, "calculationFormula不能为空");
        Assert.notNull(details1, "stockinB不能为空");
        Assert.notNull(bdInvbasdocEntity, "bdInvbasdocEntity不能为空");

        //totalPayAmount只能是金额
        String totalPayAmount = null;
        if (isCheckShopChoose) {
//            //取结存
//            List<BdInvmandocEntity> bdInvmandocEntityArrayList = new ArrayList<>();
//            bdInvmandocEntityArrayList.add(bdInvmandocEntity);
//            List<IaPeriodaccountEntity> iaPeriodaccountEntityList = balanceUnitPriceUtil.queryBalanceUnitPrice(bdInvmandocEntityArrayList);
//            if (iaPeriodaccountEntityList != null && iaPeriodaccountEntityList.size() > 0) {
//                calculationFormula.append("U结存金额");
//                //结存金额
//                logger.info("店铺：{} 取O结存价", header.getStoreCode());
//                IaPeriodaccountEntity iaPeriodaccountEntity = iaPeriodaccountEntityList.get(0);
//                String nabmny = iaPeriodaccountEntity.getNabmny();
//                if (nabmny == null || "".equals(nabmny)) {
//                    nabmny = "0";
//                }
//                BigDecimal nabmnyBigDecimal = new BigDecimal(nabmny);
//                if (!"0".equals(nabmnyBigDecimal.stripTrailingZeros().toPlainString())) {
//                    totalPayAmount = nabmnyBigDecimal.stripTrailingZeros().toPlainString();
//                } else {
//                    //如果结存金额为0，则设置为0
//                    totalPayAmount = "0";
//                }
//            } else {
//                //取采购价
//                List<BdInvmandocEntity> bdInvmandocEntityArrayList1 = new ArrayList<>();
//                bdInvmandocEntityArrayList1.add(bdInvmandocEntity);
//                List<PoOrderBEntity> poOrderBEntityList = balanceUnitPriceUtil.queryPurchaseUnitPriceByInvcodes(bdInvmandocEntityArrayList1);
//                if (poOrderBEntityList != null && poOrderBEntityList.size() > 0) {
//                    calculationFormula.append("U采购金额");
//                    logger.info("店铺：{} 取O采购价", header.getStoreCode());
//                    String norgtaxprice = poOrderBEntityList.get(0).getNorgtaxprice();//原币含税单价
////                    String nordernum = poOrderBEntityList.get(0).getNordernum();//订货数量
//                    if ("0".equals(new BigDecimal(norgtaxprice).stripTrailingZeros().toPlainString())) {
//                        //如果采购单价都为0，那么金额也为0
//                        totalPayAmount = "0";
//                    } else {
//                        //采购金额的确定=原币含税单价*O实退数量
////                        BigDecimal norgtaxpriceBigDecimal = new BigDecimal(norgtaxprice);
////                        BigDecimal nordernumBigDecimal = new BigDecimal(nordernum);
////                        BigDecimal multiply = norgtaxpriceBigDecimal.multiply(nordernumBigDecimal).setScale(2, BigDecimal.ROUND_HALF_UP);
////                        totalPayAmount = multiply.stripTrailingZeros().toPlainString();
//                        BigDecimal totalPayAmountBigDecimal = new BigDecimal(norgtaxprice).multiply(new BigDecimal(stockinB.getReceivedQty())).setScale(2, BigDecimal.ROUND_HALF_UP);
//                        totalPayAmount = totalPayAmountBigDecimal.stripTrailingZeros().toPlainString();
//                    }
//                } else {
//                    Assert.state(false, "店铺：{} 存货管理档案主键：{} 既没有结存价、也没有采购价！", header.getStoreCode(), bdInvmandocEntity.getPkInvmandoc());
//                }
//            }
            totalPayAmount = getRefsaleprice(bdInvmandocEntity, bdInvbasdocEntity, calculationFormula, details1, header);
        } else {
            //O用户实退
            logger.info("店铺：{} 取O实付金额", header.getStoreCode());
            calculationFormula.append("O实退金额");
            totalPayAmount = afterSalesOrder.getTotalAmount();
        }
        return totalPayAmount;
    }

    /**
     * 打印售后入库单单号
     *
     * @author liuyang
     */
    private void splicingPrintingOrderNumber(List<PassiveStorageResponse.Data> passiveStorageResponseDataDtoArrayList, String sceneType, String startTime, String endTime, String code) {
        try {
            if (passiveStorageResponseDataDtoArrayList != null && passiveStorageResponseDataDtoArrayList.size() > 0) {
                String codesJoined = passiveStorageResponseDataDtoArrayList.stream().map(PassiveStorageResponse.Data::getHeader).map(PassiveStorageResponse.Header::getReceiptCode).collect(Collectors.joining(","));
                logger.info("{} 售后入库单单号：{} 查询条件：{} ～ {} code：{}", sceneType, codesJoined, startTime, endTime, code);
            } else {
                logger.info("{} 售后入库单单号：{} 查询条件：{} ～ {} code：{}", sceneType, "无", startTime, endTime, code);
            }
        } catch (Exception e) {
            logger.error("splicingPrintingOrderNumber方法抛出异常", e);
        }
    }

    /**
     * 获取参考售价
     *
     * @param bdInvmandocEntity     存货管理档案
     * @param bdInvbasdocEntity     存货基本档案
     * @param calculationFormulaStr 计算公式
     * @param details               O无源入库单明细行
     * @param header                O售后入库单表头
     * @author liuyang
     */
    private String getRefsaleprice(BdInvmandocEntity bdInvmandocEntity, BdInvbasdocEntity bdInvbasdocEntity, StringBuffer calculationFormulaStr, PassiveStorageResponse.Details details, PassiveStorageResponse.Header header) throws Exception {
        Assert.notNull(bdInvmandocEntity, "bdInvmandocEntity不能为空!");
        Assert.notNull(bdInvbasdocEntity, "bdInvbasdocEntity不能为空!");
        Assert.notNull(calculationFormulaStr, "calculationFormulaStr不能为空！");
        Assert.notNull(details, "goodsRertunSonDetailsDto不能为空！");
        Assert.notNull(header, "header不能为空");

        //U参考售价
        String refsaleprice = bdInvmandocEntity.getRefsaleprice();
        Assert.notNull(refsaleprice, "存货：{} 公司：{} 不存在参考售价，请维护！", bdInvbasdocEntity.getInvname(), bdInvmandocEntity.getPkCorp());

        //O实收数量
        String receivedQty = details.getQuantity();
        Assert.notNull(receivedQty, "O实收数量不能为空 O无源入库单编码：{} O明细行主键：{}", header.getReceiptCode(), details.getId());
        Assert.state(!"".equals(receivedQty), "O实收数量不能为空 O售后入库单编码：{} O明细行主键：{}", header.getReceiptCode(), details.getId());

        BigDecimal amountOfMoney = new BigDecimal(refsaleprice).multiply(new BigDecimal(receivedQty));
        String format = StrUtil.format("取U参考售价：{}*{}", refsaleprice, receivedQty);
        calculationFormulaStr.append(format);
        return amountOfMoney.stripTrailingZeros().toPlainString();
    }

    /**
     * 打印OFS单号
     *
     * @param passiveStorageResponseDataDtoArrayList 无源入库单
     * @param startTime                              开始时间
     * @param endTime                                结束时间
     * @param type                                   类型
     * @author liuyang
     */
    private void printOfsDocCode(List<PassiveStorageResponse.Data> passiveStorageResponseDataDtoArrayList, String startTime, String endTime, String type) {
        Assert.notNull(passiveStorageResponseDataDtoArrayList, "passiveStorageResponseDataDtoArrayList不能为空！");
        Assert.notNull(startTime, "startTime不能为空！");
        Assert.notNull(endTime, "endTime不能为空！");

        try {
            StringBuffer stringBuffer = new StringBuffer();
            stringBuffer.append(type);
            stringBuffer.append(" ");

            stringBuffer.append("插件：");
            stringBuffer.append(getPluginName());
            stringBuffer.append(" ");

            stringBuffer.append("开始时间：");
            stringBuffer.append(startTime);
            stringBuffer.append("结束时间：");
            stringBuffer.append(endTime);
            stringBuffer.append(" ");

            stringBuffer.append("获取到的单号：");
            String codes = passiveStorageResponseDataDtoArrayList.stream().map(headerDetailsDto -> headerDetailsDto.getHeader().getReceiptCode()).collect(Collectors.joining(","));
            stringBuffer.append(codes);
            logger.info(stringBuffer.toString());
        } catch (Exception e) {
            logger.error("{} 插件:{}，打印拉取到的单据号出错", type, getPluginName(), e);
        }
    }

    /**
     * 过滤掉没有交易成功的无源件明细行
     *
     * @param passiveStorageResponseDataList O无源件交易成功状态
     * @throws Exception 跑出可能的异常
     */
    private List<PassiveStorageResponse.Data> filterAfterSalesOrder(List<PassiveStorageResponse.Data> passiveStorageResponseDataList) throws Exception {
        List<PassiveStorageResponse.Data> filteredList = null;
        if (passiveStorageResponseDataList != null && passiveStorageResponseDataList.size() > 0) {
            filteredList = passiveStorageResponseDataList.stream().filter(stockinOrder -> {
                PassiveStorageResponse.Header header = stockinOrder.getHeader();
                if (header == null) {
                    return false;
                }
                RerturnGoodsOrderSearchData returnData = header.getRerturnGoodsOrderSearchData();
                if (returnData == null) {
                    return false;
                }
                RerturnGoodsOrderSearchHeader header1 = returnData.getHeader();
                if (header1 == null) {
                    return false;
                }
                if (header1.getRefundedAt() == null) {
                    return false;
                }
                return true;
            }).collect(Collectors.toList());
        }
        return filteredList;
    }
}