package com.hzya.frame.plugin.lets.util;

import com.hzya.frame.WebappApplication;
import com.hzya.frame.plugin.lets.ofsvo.QueryOfsSoSaleOutVo;
import com.hzya.frame.ttxofs.dto.returngoodordersearch.RerturnGoodsOrderSearchData;
import com.hzya.frame.ttxofs.dto.returngoodordersearch.RerturnGoodsOrderSearchDetails;
import com.hzya.frame.ttxofs.dto.returngoodordersearch.RerturnGoodsOrderSearchHeader;
import com.hzya.frame.ttxofs.service.OfsUnifiedService;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;

import java.util.ArrayList;
import java.util.List;

import static org.junit.Assert.*;

/**
 * @Author：liuyang
 * @Package：com.hzya.frame.plugin.lets.util
 * @Project：kangarooDataCenterV3
 * @name：OfsOrderAfterSalesAmountAllocationUtilTest
 * @Date：2024/10/10 14:22
 * @Filename：OfsOrderAfterSalesAmountAllocationUtilTest
 */
@RunWith(SpringRunner.class)
@SpringBootTest(classes = WebappApplication.class)
public class OfsOrderAfterSalesAmountAllocationUtilTest {

    Logger logger = LoggerFactory.getLogger(OfsOrderAfterSalesAmountAllocationUtilTest.class);

    @Autowired
    private OfsOrderAfterSalesAmountAllocationUtil ofsOrderAfterSalesAmountAllocationUtil;

    @Autowired
    private AfterSalesOrderUtil afterSalesOrderUtil;

    @Autowired
    private OfsUnifiedService ofsUnifiedService;

    @Test
    public void test01() throws Exception {
        ofsUnifiedService.unified(null);
    }

    @Test
    public void tocSalesAmountAllocation() {
        try {
            List<RerturnGoodsOrderSearchData> rerturnGoodsOrderSearchDataList = new ArrayList<>();

            QueryOfsSoSaleOutVo queryOfsSoSaleOutVo = new QueryOfsSoSaleOutVo();
//            queryOfsSoSaleOutVo.setCode("LETS-RO2024091900000001");
            queryOfsSoSaleOutVo.setCode("LETS-RO2023082300000025");
            afterSalesOrderUtil.getBatchOfsRertunOrder(queryOfsSoSaleOutVo, rerturnGoodsOrderSearchDataList, 1L);

            //测试一：所有的优惠金额都为零
//            RerturnGoodsOrderSearchHeader header = rerturnGoodsOrderSearchDataList.get(0).getHeader();
//            header.setPlatformDiscounts("0");
//            header.setMerchantDiscounts("0");
//            header.setExpertDiscounts("0");
//            header.setPayDiscounts("0");

            //测试二：所有优惠的金额都为null
//            RerturnGoodsOrderSearchHeader header = rerturnGoodsOrderSearchDataList.get(0).getHeader();
//            header.setPlatformDiscounts(null);
//            header.setMerchantDiscounts(null);
//            header.setExpertDiscounts(null);
//            header.setPayDiscounts(null);

            //测试三：全部存在优惠金额数值
//            RerturnGoodsOrderSearchHeader header = rerturnGoodsOrderSearchDataList.get(0).getHeader();
//            header.setPlatformDiscounts("3.75");
//            header.setMerchantDiscounts("7.88");
//            header.setExpertDiscounts("4.22");
//            header.setPayDiscounts("1.96");

            //测试四：没有商品零售价过滤
//            List<RerturnGoodsOrderSearchDetails> details = rerturnGoodsOrderSearchDataList.get(0).getDetails();
//            details.get(1).setMsrPrice(null);
//            RerturnGoodsOrderSearchHeader header = rerturnGoodsOrderSearchDataList.get(0).getHeader();
//            header.setPlatformDiscounts("3.75");
//            header.setMerchantDiscounts("7.88");
//            header.setExpertDiscounts("4.22");
//            header.setPayDiscounts("1.96");

            //测试五：部分金额不存在
//            RerturnGoodsOrderSearchHeader header = rerturnGoodsOrderSearchDataList.get(0).getHeader();
//            header.setPlatformDiscounts("3.75");
//            header.setMerchantDiscounts("7.88");
//            header.setExpertDiscounts(null);
//            header.setPayDiscounts(null);

            //测试六：商品零售价为0
//            List<RerturnGoodsOrderSearchDetails> details = rerturnGoodsOrderSearchDataList.get(0).getDetails();
//            details.get(0).setMsrPrice("0");
//            details.get(1).setMsrPrice("0");
//            RerturnGoodsOrderSearchHeader header = rerturnGoodsOrderSearchDataList.get(0).getHeader();
//            header.setPlatformDiscounts("3.75");
//            header.setMerchantDiscounts("7.88");
//            header.setExpertDiscounts("4.22");
//            header.setPayDiscounts("1.96");

            ofsOrderAfterSalesAmountAllocationUtil.tocSalesAmountAllocation(rerturnGoodsOrderSearchDataList.get(0));
            //打印结果
            ofsOrderAfterSalesAmountAllocationUtil.printAmountOfMoneyNum(rerturnGoodsOrderSearchDataList);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}