package com.hzya.frame.report.lets.service;

import com.alibaba.fastjson.JSONObject;
import com.hzya.frame.basedao.service.IBaseService;
import com.hzya.frame.report.lets.entity.TocofsSaleoutEntity;
import com.hzya.frame.web.entity.JsonResultEntity;

/**
 * root(TocofsSaleout)表服务接口
 *
 * @author makejava
 * @since 2024-08-01 17:01:32
 */
public interface ITocofsSaleoutService extends IBaseService<TocofsSaleoutEntity, String> {
    /**
     * 查询TOC/TOB销售正向流程报表数据
     *
     * @author liuyang
     */
    JsonResultEntity queryToCSalesReport(JSONObject jsonObject) throws Exception;

    /**
     * 导出TOC/TOB销售正向流程报表数据
     */
    JsonResultEntity exportToCSalesReportExcel(JSONObject jsonObject) throws Exception;

    /**
     * 查询TOC/TOB退货反向流程报表数据
     *
     * @author liuyang
     */
    JsonResultEntity queryToCReturnReport(JSONObject jsonObject) throws Exception;

    /**
     * 导出TOC/TOB退货反向流程报表数据
     *
     * @author liuyang
     */
    JsonResultEntity exportToCReturnReportExcel(JSONObject jsonObject) throws Exception;

    /**
     * 查询无源件推送数据、包含 TOB、TOC 入库、交易成功
     *
     * @author liuyang
     */
    JsonResultEntity queryPassiveComponentsReport(JSONObject jsonObject) throws Exception;

    /**
     * 导出无源件推送数据、包含 TOB、TOC 入库、交易成功，生成 Excel
     *
     * @author liuyang
     */
    JsonResultEntity queryPassiveComponentsReportExcel(JSONObject jsonObject) throws Exception;

    /**
     * 无源件退款业务查询
     *
     * @author liuyang
     */
    JsonResultEntity queryRefundPassiveComponents(JSONObject jsonObject) throws Exception;

    /**
     * 无源件退款业务查询,Excel导出
     *
     * @author liuyang
     */
    JsonResultEntity queryRefundPassiveComponentsExcel(JSONObject jsonObject) throws Exception;
}
